#if !defined(AFX_BOXLIST_H__B2957725_45C7_4FF3_9A51_1DE57E8D72B2__INCLUDED_)
#define AFX_BOXLIST_H__B2957725_45C7_4FF3_9A51_1DE57E8D72B2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// BoxList.h : header file
//

// messages sent to parent
#define BM_DRAWITEM WM_USER+1
#define BM_DRAGITEM WM_USER+2
#define BM_CANCELDRAGITEM WM_USER+3
#define BM_SELECTITEM WM_USER+4
#define BM_DBLCLICK WM_USER+5

// button color indeces
#define COLORSET_NORMAL	0
#define COLORSET_HOVER	1
#define COLORSET_DOWN	2

#define BTN_BORDER		0
#define BTN_FACE		1
#define BTN_HIGHLIGHT	2
#define BTN_SHADOW		3

struct BtnClr
{
	COLORREF border,face,highlight,shadow;
};

/////////////////////////////////////////////////////////////////////////////
// CBoxList window

class CBoxList : public CWnd
{
// Construction
public:
	CBoxList();

// Attributes
public:
	CSize GetItemSize();				// Retrieves item dimensions
	int  GetItemHeight();
	int  GetItemWidth();

	int  GetButtonPadding();			// Returns the padding between buttons and items
	int  GetButtonHeight();				// Returns the height of the buttons used

	COLORREF GetBtnColor(int nColorSet, int nItem);

	int  GetItemPadding();				// Retrieves vertical padding
	int  GetListSize();					// Retrieves number of list items
	int  GetPageSize();					// Retrieves page size

	int  GetSelected();					// Retrieves selected item index
	int  GetScroll();					// Retrieves scroll offset

	void SetItemSize(int cx, int cy);	// Sets dimensions of each item
	void SetItemSize(CSize size);

	void SetItemPadding(int nPad);
	void SetButtonPadding(int nPad);

	void SetButtonHeight(int nHeight, bool bRecalc = FALSE);

	void SetBtnColors(BtnClr *normal,	// Sets button color sets
		BtnClr *hover,
		BtnClr *down);

	void SetListSize(int nItems);		// Sets number of items in list
	void SetPageSize(int nPage);		// Sets number of items in one view (page)

	void SetPainter(void (*DrawItem)(int, CDC*));	// Sets drawing function

// Operations
public:
	void ShowButtons(bool bShow, bool bRecalc = FALSE);
	void ScrollTo(int nPos, bool bRedraw = TRUE);
	void ScrollBy(int nScroll, bool bRedraw = TRUE);
	void SetSelected(int nSel, bool bAlwaysScroll = TRUE);
	void KillMouseFocus();				// Should be called by parent

// Data
protected:

	CWnd* m_pParent;					// Parent window
	UINT m_nID;							// Identifier of control

	CDC buf;

	CScrollBar m_wndScrollBar;			// Scroll bar
	int m_nScrollBarWidth;				// Scroll width

	CRect btnUp;						// Rect for up button
	CRect btnDown;						// Rect for down button

	CRect itemRect[20];					// List of item rects

	BtnClr btn_normal;					// Color set for normal button
	BtnClr btn_hover;					// Color set for hovered button
	BtnClr btn_down;					// Color set for depressed button


	bool m_bHasMouse;					// Indicates mouse focus
	CPoint m_MousePos;					// Cursor position
	int m_MouseHover;					// Hovered item
	int m_MousePress;					// Item upon which the mouse was depressed

	int m_nXPos;						// Position of list in parent window
	int m_nYPos;						//

	int m_nItemWidth;					// Dimensions of list items
	int m_nItemHeight;					//

	int m_nItemPadding;					// Vertical distance between items

	bool m_bShowButtons;				// Indicates button state
	int m_nButtonPadding;				// Pad between buttons and item list

	int m_nButtonHeight;

	int m_nListSize;					// Number of items in the list
	int m_nPageSize;					// Number of items displayed

	int m_nScrollPos;					// Item at top of list
	int m_nScrollDir;					// Direction of scrolling
	int m_nSelected;					// Currently selected item

	void CalcLayout();					// Recalculates metrics and moves widgets

	void (__stdcall *DrawItem)(int, CDC*);
	// Pointer to function for drawing each item


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBoxList)
	//}}AFX_VIRTUAL

// Implementation
public:
	void CreateList(int x, int y, int nItemWidth, int nItemHeight, int nListSize, int nPageSize, CWnd *parent, UINT nID);
	virtual ~CBoxList();

	// Generated message map functions
protected:
	//{{AFX_MSG(CBoxList)
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnVScroll( UINT nSBCode, UINT nPos, CScrollBar* pScrollBar );
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BOXLIST_H__B2957725_45C7_4FF3_9A51_1DE57E8D72B2__INCLUDED_)
