// DestinationDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MapEdit.h"
#include "classes.h"
#include "DestinationDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDestinationDlg dialog


CDestinationDlg::CDestinationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDestinationDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDestinationDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	request_seek = false;
	seek_sel = 0;
	sel_dest = 0;

	dest.x = -1;
	dest.y = -1;
}

CDestinationDlg::CDestinationDlg(CRom* pRom, int nDest, CWnd *pParent)
	: CDialog(CDestinationDlg::IDD, pParent)
{
	ebRom = pRom;
	sel_dest = nDest;

	dest.x = -1;
	dest.y = -1;
}

void CDestinationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDestinationDlg)
	DDX_Control(pDX, IDC_CHECK_FLAG, m_Chk_Flag);
	DDX_Control(pDX, IDC_COMBO_DIR, m_Combo_Dir);
	DDX_Control(pDX, IDC_COMBO_TYPE, m_Combo_Type);
	DDX_Control(pDX, IDC_LIST_DEST, m_ListBox);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDestinationDlg, CDialog)
	//{{AFX_MSG_MAP(CDestinationDlg)
	ON_LBN_SELCHANGE(IDC_LIST_DEST, OnListBoxSelect)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	ON_BN_CLICKED(IDC_APPLY, OnApply)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_SEEK, OnSeek)
	ON_WM_CHARTOITEM()
	ON_WM_VKEYTOITEM()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDestinationDlg message handlers

BOOL CDestinationDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	if(tempmap.m_hDC == NULL) {
		tempmap.CreateCompatibleDC(GetDC());
		SelectObject((HDC)tempmap, CreateCompatibleBitmap((HDC)*GetDC(), 256, 256));
	}
	if(crosshair.m_hDC == NULL) {
		crosshair.CreateCompatibleDC(GetDC());
		CBitmap bmp;
		bmp.LoadBitmap(IDB_CROSSHAIR);
		crosshair.SelectObject(bmp);
	}

	// TODO: Add extra initialization here
	
	// load door destinations into local array for editing
	//dest = ebRom->dest;

	//for(int i = 0; i < 1280; i++)
	//	areas[i] = ebRom->object_areas[i];


	/*if(request_seek) {
		request_seek = false;

		sel_dest = seek_sel;

		ebRom->dest.entries[sel_dest].x = seek_x;
		ebRom->dest.entries[sel_dest].y = seek_y;

		SelectDest(sel_dest);

		ApplyChanges();
	}
	else*/


	// If the temporary destination object's x and y values are
	// nonnegative before showing the window, it means they have
	// been modified by the caller, and should be preserved.

	int oldx = dest.x;
	int oldy = dest.y;

	SelectDest(sel_dest);

	if(oldx != -1) dest.x = oldx;
	if(oldy != -1) dest.y = oldy;

	DisplayDestData();
	RefreshListBox();

	m_ListBox.SetTabStops(20);

	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDestinationDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here

	// hmm
	// instead of doing this, we should first paint a slightly larger region
	// into a temporary buffer, and then paint that onto our little preview
	// pane, adjusting it for precise coordinates, and adding a nifty crosshair.


	// find our destination's tile location
	dc.Draw3dRect(CRect(68, 222, 68+132, 222+68), GetSysColor(COLOR_3DSHADOW), GetSysColor(COLOR_3DHILIGHT));
	dc.Draw3dRect(CRect(69, 223, 69+130, 223+66), GetSysColor(COLOR_3DDKSHADOW), GetSysColor(COLOR_3DLIGHT));

	if(ebRom->dest.entries[sel_dest].type == DEST_DOOR) {
		int tile_x = dest.x / 4;
		int tile_y = dest.y / 4;
		int rem_x  = dest.x - (tile_x*4);
		int rem_y  = dest.y - (tile_y*4);
		tile_x -= 4;
		tile_y -= 4;

		int px = (4*32) + (rem_x*8);
		int py = (4*32) + (rem_y*8);


		ebRom->DrawMain(&tempmap, 0, 0, 8, 8, tile_x, tile_y);

		/*BITMAPINFO bmi = { { 40, 256, -256, 1, 32, BI_RGB, 0, 0, 0, 0, 0 } };
		HBITMAP bm;
		int *data;
		int xx, yy, x, y, tx, ty;
		bm = CreateDIBSection((HDC)dc, &bmi, DIB_RGB_COLORS, (void **)&data, NULL, 0);

		for(xx = 0; xx < 8; xx++) {
			for(yy = 0; yy < 8; yy++) {
				// draw a map tile
				int cy = tile_y+yy;
				int cx = tile_x+xx;

				int tile = (cy<0||cy>319||cx<0||cx>255)?0:ebRom->map_tiles[cy][cx];
				int lset = (cy<0||cy>319||cx<0||cx>255)?0:ebRom->lsets[cy][cx];
				int gset = (cy<0||cy>319||cx<0||cx>255)?0:ebRom->gsets[(cy)/4][(cx)/8];
				int tpal = (cy<0||cy>319||cx<0||cx>255)?0:ebRom->gpals[(cy)/4][(cx)/8];
				//tempmap.BitBlt(x*32,y*32,32,32,&tilesets[gset],tile*32,lset*32,SRCCOPY);

				// draw all 16 minitiles in a specific map tile
				for(y = 0; y < 4; y++) for(x = 0; x < 4; x++) {
					int b = *arranges[set_conv[gset]][tile + lset*256][y * 4 + x];

					// draw all pixels in a minitile
					for(ty = 0; ty < 8; ty++) for(tx = 0; tx < 8; tx++) {
						// x = minitile coordinate, so multiplied by 8 to draw in correct minitile
						data[32*xx + 8*x + (b & 0x4000 ? 7 - tx : tx) + 256 * 
							(32*yy + 8*y + (b & 0x8000 ? 7 - ty : ty))] =
							mpal[gset][tpal][((b & 0x1C00) >> 10) - 2][
							tilecolor(*_tilesets[set_conv[gset]][b & 0x1FF], tx, ty)];
					}
				}
			}
		}
		SetDIBitsToDevice((HDC)tempmap, 0, 0, 256, 256, 0, 0, 0, 256, data, &bmi, DIB_RGB_COLORS);
		DeleteObject(bm);
*/

		tempmap.Draw3dRect(CRect(px, py, px+8, py+8),RGB(255,0,0),RGB(255,0,0));
		dc.BitBlt(70,224,128,64,&tempmap,(2*32)+(rem_x*8)+4,(3*32)+(rem_y*8)+4,SRCCOPY);
		dc.BitBlt(70,224,128,64,&crosshair,0,0,SRCAND);
	}
	else {
		dc.FillSolidRect(70, 224, 128, 64, GetSysColor(COLOR_3DFACE));
	}

	// Do not call CDialog::OnPaint() for painting messages
}




void CDestinationDlg::RefreshListBox()
{
	m_ListBox.SetRedraw(FALSE);	// turn drawing off

	m_ListBox.ResetContent();

	for(int i = 0; i < ebRom->dest.num_dest; i++) {
		CString str;

		str.Format("%d:	", i);

		switch(ebRom->dest.entries[i].type) {
		case DEST_DOOR:
			str.Format("%d:	Door	-	(%d, %d)", i, ebRom->dest.entries[i].x, ebRom->dest.entries[i].y);
			break;
		case DEST_OBJECT: case DEST_PERSON:
			str.Format("%d:	Object -	%s", i, FormatSNESAdr(ebRom->dest.entries[i].pointer));
			break;
		case DEST_SWITCH:
			str.Format("%d:	Switch -	%s", i, FormatSNESAdr(ebRom->dest.entries[i].eventFlag));
			break;
		}
		m_ListBox.AddString(str);
	}

	m_ListBox.SetRedraw(TRUE);

	m_ListBox.SetCurSel(sel_dest);
}


void CDestinationDlg::DisplayDestData()
{
	SetDlgItemText(IDC_EDIT_POINTER, FormatSNESAdr(dest.pointer));
	SetDlgItemText(IDC_EDIT_FLAG, FormatSNESAdr(dest.eventFlag));
	m_Chk_Flag.SetCheck(dest.checkFlag);

	SetDlgItemInt(IDC_EDIT_X, dest.x);
	SetDlgItemInt(IDC_EDIT_Y, dest.y);
	SetDlgItemInt(IDC_EDIT_STYLE, dest.style);

	m_Combo_Dir.SetCurSel(dest.direction);

	m_Combo_Dir.EnableWindow(FALSE);
	m_Chk_Flag.EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_X)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_Y)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_STYLE)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_FLAG)->EnableWindow(FALSE);
	GetDlgItem(IDC_SEEK)->EnableWindow(FALSE);

	switch(dest.type) {
	case DEST_DOOR:
		m_Combo_Type.SetCurSel(0);

		m_Combo_Dir.EnableWindow();
		m_Chk_Flag.EnableWindow();
		GetDlgItem(IDC_EDIT_X)->EnableWindow();
		GetDlgItem(IDC_EDIT_Y)->EnableWindow();
		GetDlgItem(IDC_EDIT_STYLE)->EnableWindow();
		GetDlgItem(IDC_EDIT_FLAG)->EnableWindow();
		GetDlgItem(IDC_SEEK)->EnableWindow();

		break;
	case DEST_OBJECT: case DEST_PERSON:
		m_Combo_Type.SetCurSel(1);

		break;
	case DEST_SWITCH:
		m_Combo_Type.SetCurSel(2);

		m_Chk_Flag.EnableWindow();
		GetDlgItem(IDC_EDIT_FLAG)->EnableWindow();

		break;
	}

	SetDlgItemText(IDC_EDIT_DADR, FormatSNESAdr(dest.address));

	Invalidate(FALSE);
}


void CDestinationDlg::OnListBoxSelect() 
{
	SelectDest(m_ListBox.GetCurSel());
}



void CDestinationDlg::OnAdd() 
{
	AddDestination(&ebRom->dest, DEST_DOOR, 0, 0, 0, 0, 0, false, 0);

	InsertDestString(ebRom->dest.num_dest-1, -1);

	SelectDest(ebRom->dest.num_dest-1);
}


void CDestinationDlg::OnRemove() 
{
	int destination = m_ListBox.GetCurSel();

	RemoveDestination(&ebRom->dest, destination, ebRom->object_areas);

	m_ListBox.SetRedraw(FALSE);

	for(int i = 0; i < ebRom->dest.num_dest; i++)
		InsertDestString(i, -1);

	for(i = 0; i < ebRom->dest.num_dest+1; i++) {
		m_ListBox.DeleteString(0);
		m_ListBox.SetCurSel(destination);
	}

	if(destination >= ebRom->dest.num_dest) destination = ebRom->dest.num_dest - 1;

	SelectDest(destination);

	DisplayDestData();

	m_ListBox.SetRedraw(TRUE);
	Invalidate(FALSE);
}



void CDestinationDlg::OnApply() 
{
	ApplyChanges();
}



void CDestinationDlg::InsertDestString(int i, int loc)
{
	CString str;

	switch(ebRom->dest.entries[i].type) {
	case DEST_DOOR:
		str.Format("%d:	Door	-	(%d, %d)", i, ebRom->dest.entries[i].x, ebRom->dest.entries[i].y);
		break;
	case DEST_OBJECT: case DEST_PERSON:
		str.Format("%d:	Object -	%s", i, FormatSNESAdr(ebRom->dest.entries[i].pointer));
		break;
	case DEST_SWITCH:
		str.Format("%d:	Switch -	%s", i, FormatSNESAdr(ebRom->dest.entries[i].eventFlag));
		break;
	}
	m_ListBox.InsertString(loc, str);
}



void CDestinationDlg::SelectDest(int destination)
{
	sel_dest = destination;
	dest = ebRom->dest.entries[sel_dest];

	m_ListBox.SetCurSel(destination);

	DisplayDestData();
}

void CDestinationDlg::ApplyChanges()
{
	switch(m_Combo_Type.GetCurSel()) {
	case 0:	// door
		ebRom->dest.entries[sel_dest].type = DEST_DOOR;
		break;
	case 1:	// object
		ebRom->dest.entries[sel_dest].type = DEST_OBJECT;
		break;
	case 2:	// switch
		ebRom->dest.entries[sel_dest].type = DEST_SWITCH;
		break;
	}

	ebRom->dest.entries[sel_dest].x = GetDlgItemInt(IDC_EDIT_X);
	ebRom->dest.entries[sel_dest].y = GetDlgItemInt(IDC_EDIT_Y);
	ebRom->dest.entries[sel_dest].style = GetDlgItemInt(IDC_EDIT_STYLE);

	ebRom->dest.entries[sel_dest].direction = m_Combo_Dir.GetCurSel();

	CString str;

	GetDlgItemText(IDC_EDIT_POINTER, str);
	ebRom->dest.entries[sel_dest].pointer = DeformatSNESAdr(str);

	GetDlgItemText(IDC_EDIT_FLAG, str);
	ebRom->dest.entries[sel_dest].eventFlag = DeformatSNESAdr(str);

	ebRom->dest.entries[sel_dest].checkFlag = m_Chk_Flag.GetCheck()!=0;

	// refresh list box
	m_ListBox.DeleteString(sel_dest);
	InsertDestString(sel_dest, sel_dest);
	SelectDest(sel_dest);
}


void CDestinationDlg::OnSeek() 
{
	// First, save our data
	//ApplyChanges();

	request_seek = true;
	seek_sel = sel_dest;

	seek_x = ebRom->dest.entries[sel_dest].x;
	seek_y = ebRom->dest.entries[sel_dest].y;

	EndDialog(42);
}



void CDestinationDlg::OnOK() 
{
	// apply any latent changes to the temporary array
	ApplyChanges();

/*	// copy modified data to ROM object
	ebRom->dest.entries = new DestinationEntry[ebRom->dest.num_dest];
	ebRom->dest.num_dest = dest.num_dest;

	for(int i = 0; i < ebRom->dest.num_dest; i++)
		ebRom->dest.entries[i] = dest.entries[i];

	for(i = 0; i < 1280; i++)
		ebRom->object_areas[i] = areas[i];
*/

	CDialog::OnOK();
}




void CDestinationDlg::AddDestination(DestinationList *dest, int type, int pointer, int x, int y, int direction, int eventFlag, bool checkFlag, int style)
{
	// again, the entire array needs to be backed up during this operation
	DestinationEntry *temp = new DestinationEntry[dest->num_dest];

	for(int i = 0; i < dest->num_dest; i++)
		temp[i] = dest->entries[i];

	dest->entries = new DestinationEntry[dest->num_dest+1];

	for(i = 0; i < dest->num_dest; i++)
		dest->entries[i] = temp[i];

	dest->entries[dest->num_dest].type = type;
	dest->entries[dest->num_dest].pointer = pointer;
	dest->entries[dest->num_dest].x = x;
	dest->entries[dest->num_dest].y = y;
	dest->entries[dest->num_dest].direction = direction;
	dest->entries[dest->num_dest].eventFlag = eventFlag;
	dest->entries[dest->num_dest].checkFlag = checkFlag;
	dest->entries[dest->num_dest].style = style;

	dest->num_dest++;

	delete temp;

}

void CDestinationDlg::RemoveDestination(DestinationList *dest, int destination, ObjectArea *areas)
{
	DestinationEntry *temp = new DestinationEntry[dest->num_dest];

	for(int i = 0; i < dest->num_dest; i++)
		temp[i] = dest->entries[i];

	dest->num_dest--;

	for(i = destination; i < dest->num_dest; i++)
		temp[i] = temp[i+1];

	dest->entries = new DestinationEntry[dest->num_dest];

	for(i = 0; i < dest->num_dest; i++)
		dest->entries[i] = temp[i];

	delete temp;

	// okay, we're not done yet.
	// here's the tricky part:
	// all the destination entries after the one we just deleted will get bumped back
	// one position. This also means that a very large number of door entries will
	// now have incorrect destination indexes attached to them.
	// basically, we have to find all the door entries that use those destinations above
	// the one we just deleted, and decrement their destination index values, so they'll
	// be in line with the new ones.
	// as for any doors that used the destination we just deleted?
	// heheh, well, they get set to zero.

	for(i = 0; i < 1280; i++) {
		for(int j = 0; j < ebRom->door_entry[i].num_doors; j++) {
			if(ebRom->door_entry[i][j].destindex > destination)
				ebRom->door_entry[i][j].destindex--;

			if(ebRom->door_entry[i][j].destindex == destination) {
				ebRom->door_entry[i][j].destindex = 0;
				ebRom->door_entry[i][j].null_dest = true;
			}
		}
	}
}

void CDestinationDlg::ChangeDestination(DestinationList *dest, int destination, int pointer, int x, int y, int eventFlag, bool checkFlag, int style)
{
	dest->entries[destination].pointer = pointer;
	dest->entries[destination].x = x;
	dest->entries[destination].y = y;
	dest->entries[destination].eventFlag = eventFlag;
	dest->entries[destination].checkFlag = checkFlag;
	dest->entries[destination].style = style;
}



int CDestinationDlg::OnCharToItem(UINT nChar, CListBox* pListBox, UINT nIndex) 
{
	return CDialog::OnCharToItem(nChar, pListBox, nIndex);
}

int CDestinationDlg::OnVKeyToItem(UINT nKey, CListBox* pListBox, UINT nIndex) 
{
	// TODO: Add your message handler code here and/or call default
	if(nKey == 46)
	{
		int destination = m_ListBox.GetCurSel();

		RemoveDestination(&ebRom->dest, destination, ebRom->object_areas);

		m_ListBox.SetRedraw(FALSE);

		for(int i = 0; i < ebRom->dest.num_dest; i++)
			InsertDestString(i, -1);

		for(i = 0; i < ebRom->dest.num_dest+1; i++) {
			m_ListBox.DeleteString(0);
			m_ListBox.SetCurSel(destination);
		}

		if(destination >= ebRom->dest.num_dest) destination = ebRom->dest.num_dest - 1;

		SelectDest(destination);

		DisplayDestData();

		m_ListBox.SetRedraw(TRUE);
		Invalidate(FALSE);
	}
	return CDialog::OnVKeyToItem(nKey, pListBox, nIndex);
}
