// DoorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MapEdit.h"
#include "DoorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int grad = 0;
int incr = 15;
int speed = 40;

CString txt = "Warning!";

BOOL edit_ready = FALSE;

/////////////////////////////////////////////////////////////////////////////
// CDoorDlg dialog


CDoorDlg::CDoorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDoorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDoorDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

}


void CDoorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDoorDlg)
	DDX_Control(pDX, IDC_DESTSPIN, m_DestSpin);
	DDX_Control(pDX, IDC_COMBO_TYPE, m_Combo_Type);
	DDX_Control(pDX, IDC_LIST_DEST, m_ListBox);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDoorDlg, CDialog)
	//{{AFX_MSG_MAP(CDoorDlg)
	ON_CBN_SELCHANGE(IDC_COMBO_TYPE, OnSelectType)
	ON_BN_CLICKED(IDC_EDITDEST, OnBtnEditDest)
	ON_WM_PAINT()
	ON_EN_CHANGE(IDC_EDIT_DEST, OnEditDest)
	ON_LBN_SELCHANGE(IDC_LIST_DEST, OnSelectDest)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDoorDlg message handlers

BOOL CDoorDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Only create once
	if(ropewin.m_hWnd == NULL) ropewin.Create(IDD_DOOR_ROPEDLG, this);
	if(escwin.m_hWnd == NULL) escwin.Create(IDD_DOOR_ESCDLG, this);
	if(stairwin.m_hWnd == NULL) stairwin.Create(IDD_DOOR_STAIRDLG, this);

	m_bmpCrosshair.LoadBitmap(IDB_CROSSHAIR);
	/*
	if(tempmap.m_hDC == NULL) {
		tempmap.CreateCompatibleDC(GetDC());
		SelectObject((HDC)tempmap, CreateCompatibleBitmap((HDC)*GetDC(), 256, 256));
	}
	if(buf.m_hDC == NULL) {
		buf.CreateCompatibleDC(GetDC());
		SelectObject((HDC)buf, CreateCompatibleBitmap((HDC)*GetDC(), 128, 64));
		buf2.CreateCompatibleDC(GetDC());
		SelectObject((HDC)buf2, CreateCompatibleBitmap((HDC)*GetDC(), 512, 512));
	}
	if(tbuf.m_hDC == NULL) {
		tbuf.CreateCompatibleDC(GetDC());

		// create bitmap surface
		SelectObject((HDC)tbuf, CreateCompatibleBitmap((HDC)*GetDC(), 128, 64));

		// set font
		CFont font;
		font.CreatePointFont(140,"Arial Black");
		tbuf.SelectObject(font);

		// set text characteristics
		tbuf.SetBkMode(OPAQUE);
		tbuf.SetTextColor(RGB(255,0,0));
		tbuf.SetBkColor(RGB(0,0,0));
		tbuf.FillSolidRect(0,0,256,64,RGB(0,0,0));
	}
	if(crosshair.m_hDC == NULL) {
		crosshair.CreateCompatibleDC(GetDC());
		CBitmap bmp;
		bmp.LoadBitmap(IDB_CROSSHAIR);
		crosshair.SelectObject(bmp);
	}*/



	// copy door data from ROM
	// (pointer must be initialized prior to creating this window)

	door = ebRom->door_entry[n_area][n_door];
	//door = ebRom->object_areas[n_area].doors[n_door];

	m_DestSpin.SetRange(0, ebRom->dest.num_dest-1);

	// Display data and stuff
	RefreshListBox();
	DisplayDoorData();

	edit_ready = TRUE;

	SetTimer(0, speed, NULL);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDoorDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here

}

void CDoorDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	CDC buffer;		// Back buffer for entire operation
	CBitmap buffer_bmp;

	CDC tbuf;		// Buffer for text color operations
	CBitmap tbuf_bmp;

	CDC crosshair;	// DC for crosshair bitmap

	buffer.CreateCompatibleDC(&dc);
	buffer_bmp.CreateCompatibleBitmap(&dc, 255, 255);

	tbuf.CreateCompatibleDC(&dc);
	tbuf_bmp.CreateCompatibleBitmap(&dc, 255, 64);

	crosshair.CreateCompatibleDC(&dc);

	CBitmap *buffer_bmp_old = buffer.SelectObject(&buffer_bmp);
	CBitmap *tbuf_bmp_old = tbuf.SelectObject(&tbuf_bmp);
	CBitmap *ch_bmp_old = crosshair.SelectObject(&m_bmpCrosshair);


	CFont font;
	font.CreatePointFont(140,"Arial Black");

	CFont *fnt_old = tbuf.SelectObject(&font);
	
	
	buffer.Draw3dRect(CRect(0, 0, 132, 68), GetSysColor(COLOR_3DSHADOW), GetSysColor(COLOR_3DHILIGHT));
	buffer.Draw3dRect(CRect(1, 1, 131, 67), GetSysColor(COLOR_3DDKSHADOW), GetSysColor(COLOR_3DLIGHT));


	if(door.flags == DEST_DOOR || door.flags == DEST_SWITCH || door.flags == DEST_OBJECT || door.flags == DEST_PERSON)
	{

		if(ebRom->dest.entries[door.destindex].type == DEST_DOOR)
		{
			int tile_x = ebRom->dest.entries[door.destindex].x / 4;
			int tile_y = ebRom->dest.entries[door.destindex].y / 4;
			int rem_x  = ebRom->dest.entries[door.destindex].x - (tile_x*4);
			int rem_y  = ebRom->dest.entries[door.destindex].y - (tile_y*4);
			tile_x -= 4;
			tile_y -= 4;

			int px = (4*32) + (rem_x*8);
			int py = (4*32) + (rem_y*8);

			ebRom->DrawMain(&buffer, 0, 0, 8, 8, tile_x, tile_y);


			buffer.Draw3dRect(CRect(px, py, px+8, py+8),RGB(255,0,0),RGB(255,0,0));

			// Shift the image a bit
			buffer.BitBlt(2, 2, 132, 68, &buffer, (2*32)+(rem_x*8)+4, (3*32)+(rem_y*8)+4, SRCCOPY);

			buffer.BitBlt(2, 2, 132, 68, &crosshair, 0, 0, SRCAND);


		}
		else
		{
			buffer.FillSolidRect(2, 2, 128, 64, GetSysColor(COLOR_3DFACE));
		}


		// check for a mismatch
		int f = door.flags;
		int t = ebRom->dest.entries[door.destindex].type;

		if(f != t && !((f == DEST_OBJECT || f == DEST_PERSON) && (t == DEST_OBJECT)))  {
			tbuf.SetTextColor(RGB(255-grad, 0, 0));
			tbuf.FillSolidRect(0,0,256,64,RGB(0,0,0));
			tbuf.TextOut(5,38,txt);

			COLORREF c;
			int c2;

			int cR;
			int cG;
			int cB;

			COLORREF nc;


			for(int i = 0; i < 128; i++)
			{
				for(int j = 0; j < 64; j++)
				{
					c2 = tbuf.GetPixel(i, j);

					if(c2 != 0)
					{
						c = buffer.GetPixel(i,j);
						cR = (c & 0x000000FF);
						cG = (c & 0x0000FF00) >> 8;
						cB = (c & 0x00FF0000) >> 16;

						nc = RGB(c2>cR?c2:cR, 0+((cG*grad)/255), 0+((cB*grad)/255));

						buffer.SetPixel(i, j, nc);
					}
				}
			}
		}
	}

	

	//dc.BitBlt(53, 140, 132, 68, NULL, 0, 0, BLACKNESS);
	dc.BitBlt(53, 140, 132, 68, &buffer, 0, 0, SRCCOPY);

	buffer.SelectObject(buffer_bmp_old);
	crosshair.SelectObject(ch_bmp_old);
	tbuf.SelectObject(tbuf_bmp_old);
	tbuf.SelectObject(fnt_old);

	// Do not call CDialog::OnPaint() for painting messages
}


void CDoorDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(door.flags == DEST_DOOR || door.flags == DEST_SWITCH || door.flags == DEST_OBJECT || door.flags == DEST_PERSON) {
		grad+=incr;

		if(grad >= 255) {
			grad = 0;
			if(txt == "Mismatch!") {
				txt = "Warning!";
			}
			else {
				txt = "Mismatch!";
			}
		}

		InvalidateRect(CRect(53,140,53+130,140+66), FALSE);
	}

	CDialog::OnTimer(nIDEvent);
}


void CDoorDlg::OnSelectType() 
{
	door.flags = m_Combo_Type.GetCurSel();
	DisplayDoorData();
}


void CDoorDlg::OnOK()
{
	if(GetDlgItemInt(IDC_EDIT_DEST) >= (unsigned)ebRom->dest.num_dest)
		AfxMessageBox("ERROR: Invalid door destination.\n\nDestination index greater than number of actual destinations.\nFor those who haven't figured it out already, this is a bad thing.");
	else {
		ApplyChanges();
		edit_ready = FALSE;
		KillTimer(0);
		CDialog::OnOK();
	}
}


void CDoorDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	edit_ready = FALSE;
	KillTimer(0);
	CDialog::OnCancel();
}


void CDoorDlg::OnBtnEditDest() 
{
	if(GetDlgItemInt(IDC_EDIT_DEST) >= (unsigned)ebRom->dest.num_dest)
		AfxMessageBox("ERROR: Invalid door destination.\n\nDestination index greater than number of actual destinations.\nFor those who haven't figured it out already, this is a bad thing.");
	else {
		ApplyChanges();
		edit_ready = FALSE;
		KillTimer(0);

		// End dialog with destination editor code (42)
		EndDialog(42);
	}
}


void CDoorDlg::RefreshListBox()
{
	m_ListBox.SetRedraw(FALSE);	// turn drawing off

	m_ListBox.SetTabStops(20);

	m_ListBox.ResetContent();

	for(int i = 0; i < ebRom->dest.num_dest; i++) {
		CString str;

		str.Format("%d:	", i);

		switch(ebRom->dest.entries[i].type) {
		case DEST_DOOR:
			str.Format("%d:	Door	-	(%d, %d)", i, ebRom->dest.entries[i].x, ebRom->dest.entries[i].y);
			break;
		case DEST_OBJECT: case DEST_PERSON:
			str.Format("%d:	Object -	%s", i, FormatSNESAdr(ebRom->dest.entries[i].pointer));
			break;
		case DEST_SWITCH:
			str.Format("%d:	Switch -	%s", i, FormatSNESAdr(ebRom->dest.entries[i].eventFlag));
			break;
		}
		m_ListBox.AddString(str);
	}

	m_ListBox.SetRedraw(TRUE);

	m_ListBox.SetCurSel(door.destindex);
}



void CDoorDlg::DisplayDoorData()
{
	m_Combo_Type.SetCurSel(door.flags);
	SetDlgItemInt(IDC_EDIT_X, door.x);
	SetDlgItemInt(IDC_EDIT_Y, door.y);

	ropewin.ShowWindow(SW_HIDE);
	escwin.ShowWindow(SW_HIDE);
	stairwin.ShowWindow(SW_HIDE);
	GetDlgItem(IDC_EDIT_DEST)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_DESTSPIN)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_EDITDEST)->EnableWindow(FALSE);
	m_ListBox.EnableWindow(FALSE);

	switch(door.flags) {
	case DEST_SWITCH:
	case DEST_DOOR:
	case DEST_OBJECT:
	case DEST_PERSON:
		GetDlgItem(IDC_EDIT_DEST)->ShowWindow(SW_SHOWNORMAL);
		GetDlgItem(IDC_DESTSPIN)->ShowWindow(SW_SHOWNORMAL);
		SetDlgItemInt(IDC_EDIT_DEST, door.destindex);

		GetDlgItem(IDC_EDITDEST)->EnableWindow(TRUE);
		m_ListBox.EnableWindow(TRUE);
		m_ListBox.SetCurSel(door.destindex);
		break;

	case DEST_ROPE:
		ropewin.ShowWindow(SW_SHOWNORMAL);
		if(door.ropetype == 0)
			ropewin.m_Sel_Ladder.SetCheck(1);
		else
			ropewin.m_Sel_Rope.SetCheck(1);
		break;

	case DEST_STAIR:
		stairwin.ShowWindow(SW_SHOWNORMAL);

		stairwin.m_Sel_UL.SetCheck(door.direction == 0);
		stairwin.m_Sel_UR.SetCheck(door.direction == 1);
		stairwin.m_Sel_DL.SetCheck(door.direction == 2);
		stairwin.m_Sel_DR.SetCheck(door.direction == 3);

	case DEST_ESCALATOR:
		escwin.ShowWindow(SW_SHOWNORMAL);

		if(door.is_esc_end) {
			escwin.m_Chk_End.SetCheck(1);
			escwin.m_Sel_UL.EnableWindow(FALSE);
			escwin.m_Sel_UR.EnableWindow(FALSE);
			escwin.m_Sel_DL.EnableWindow(FALSE);
			escwin.m_Sel_DR.EnableWindow(FALSE);
		}
		else {
			escwin.m_Chk_End.SetCheck(0);
			escwin.m_Sel_UL.EnableWindow();
			escwin.m_Sel_UR.EnableWindow();
			escwin.m_Sel_DL.EnableWindow();
			escwin.m_Sel_DR.EnableWindow();

			escwin.m_Sel_UL.SetCheck(door.direction == 0);
			escwin.m_Sel_UR.SetCheck(door.direction == 1);
			escwin.m_Sel_DL.SetCheck(door.direction == 2);
			escwin.m_Sel_DR.SetCheck(door.direction == 3);
		}

		break;
	}
}



void CDoorDlg::ApplyChanges()
{
	// Get data from controls

	door.flags = m_Combo_Type.GetCurSel();
	door.x = GetDlgItemInt(IDC_EDIT_X);
	door.y = GetDlgItemInt(IDC_EDIT_Y);

	switch(door.flags) {
	case DEST_SWITCH:
	case DEST_DOOR:
	case DEST_OBJECT:
	case DEST_PERSON:
		door.destindex = GetDlgItemInt(IDC_EDIT_DEST);
		break;
	case DEST_ROPE:
		door.ropetype = ropewin.m_Sel_Rope.GetCheck();
		break;
	case DEST_STAIR:
		if(stairwin.m_Sel_UL.GetCheck()) door.direction = 0;
		if(stairwin.m_Sel_UR.GetCheck()) door.direction = 1;
		if(stairwin.m_Sel_DL.GetCheck()) door.direction = 2;
		if(stairwin.m_Sel_DR.GetCheck()) door.direction = 3;
		break;
	case DEST_ESCALATOR:
		if(escwin.m_Sel_UL.GetCheck()) door.direction = 0;
		if(escwin.m_Sel_UR.GetCheck()) door.direction = 1;
		if(escwin.m_Sel_DL.GetCheck()) door.direction = 2;
		if(escwin.m_Sel_DR.GetCheck()) door.direction = 3;
		if(escwin.m_Chk_End.GetCheck()) door.is_esc_end = 1;
		else door.is_esc_end = 0;
	}

	// Copy changed door back into ROM
	ebRom->door_entry[n_area][n_door] = door;

	// Redisplay stuff
	DisplayDoorData();


}

void CDoorDlg::OnEditDest() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	if(edit_ready) {
		int newdest = GetDlgItemInt(IDC_EDIT_DEST);
		if(newdest < ebRom->dest.num_dest) {
			door.destindex = newdest;

			if(m_ListBox.m_hWnd != NULL) {
				m_ListBox.SetRedraw(FALSE);
				m_ListBox.SetCurSel(newdest);
				m_ListBox.SetRedraw(TRUE);
			}

			Invalidate(FALSE);
		}
	}
}


void CDoorDlg::OnSelectDest() 
{
	// TODO: Add your control notification handler code here
	door.destindex = m_ListBox.GetCurSel();
	DisplayDoorData();
	m_ListBox.SetFocus();
}





