// EditorEnemyGroupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MapEdit.h"
#include "EditorEnemyGroupDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditorEnemyGroupDlg dialog


CEditorEnemyGroupDlg::CEditorEnemyGroupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditorEnemyGroupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditorEnemyGroupDlg)
	m_bShowBlend = FALSE;
	m_nLayerShown = 0;
	//}}AFX_DATA_INIT
	m_nSelGroup = 0;
}


CEditorEnemyGroupDlg::CEditorEnemyGroupDlg(CRom* pRom, int nSel, CWnd* pParent /*=NULL*/)
	: CDialog(CEditorEnemyGroupDlg::IDD, pParent)
{
	//{{
	m_bShowBlend = TRUE;
	m_nLayerShown = 0;
	//}}

	Rom = pRom;
	m_nSelGroup = nSel;
}


void CEditorEnemyGroupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditorEnemyGroupDlg)
	DDX_Control(pDX, IDC_SPIN2, m_Spin2);
	DDX_Control(pDX, IDC_SPIN1, m_Spin1);
	DDX_Control(pDX, IDC_COMBO_GROUP, m_Combo_Group);
	DDX_Control(pDX, IDC_LIST_ENEMIES, m_EnemyList);
	DDX_Check(pDX, IDC_CHECK_BLEND, m_bShowBlend);
	DDX_Radio(pDX, IDC_RADIO_BGL1, m_nLayerShown);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditorEnemyGroupDlg, CDialog)
	//{{AFX_MSG_MAP(CEditorEnemyGroupDlg)
	ON_WM_PAINT()
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST_ENEMIES, OnGetdispinfoListEnemies)
	ON_EN_CHANGE(IDC_EDIT_BGL1, OnChangeEditBG1)
	ON_EN_CHANGE(IDC_EDIT_BGL2, OnChangeEditBG2)
	ON_CBN_SELCHANGE(IDC_COMBO_GROUP, OnSelchangeComboGroup)
	ON_BN_CLICKED(IDC_CHECK_BLEND, OnCheckBlend)
	ON_BN_CLICKED(IDC_RADIO_BGL1, OnRadioBgl1)
	ON_BN_CLICKED(IDC_RADIO_BGL2, OnRadioBgl2)
	ON_BN_CLICKED(IDC_BTN_APPLY, OnBtnApply)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN1, OnDeltaposSpin1)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN2, OnDeltaposSpin2)
	ON_BN_CLICKED(IDC_BTN_SAVE, OnBtnSave)
	ON_BN_CLICKED(IDC_BTN_ADD, OnBtnAdd)
	ON_BN_CLICKED(IDC_BTN_REM, OnBtnRem)
	ON_CBN_SELCHANGE(IDC_COMBO_LETTERBOX, OnSelectLetterbox)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditorEnemyGroupDlg message handlers

BOOL CEditorEnemyGroupDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	listbox.CreateList(18, 58, 170, 49, 230, 7, this, 0);
	listbox.ShowButtons(FALSE, TRUE);

	m_EnemyList.InsertColumn(0, "Enemies:", LVCFMT_LEFT, 260, 0);
	m_EnemyList.InsertColumn(1, "", LVCFMT_LEFT, 0, 0);

	FillGroupList();
	m_Combo_Group.SetCurSel(m_nSelGroup);

	m_Spin1.SetBuddy(GetDlgItem(IDC_EDIT_BGL1));
	m_Spin2.SetBuddy(GetDlgItem(IDC_EDIT_BGL2));

	m_Spin1.SetRange(0, 0x146);
	m_Spin2.SetRange(0, 0x146);


	update_edit = true;

	SelectGroup(m_nSelGroup);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}




void CEditorEnemyGroupDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	//CDC bg;
	//CBitmap bmp;

	//bg.CreateCompatibleDC(&dc);
	//bmp.CreateCompatibleBitmap(&dc, 256, 244);

	//CBitmap *bmp_old = bg.SelectObject(&bmp);

	BlendBGs(&dc, 363, 43, 256, 224);

	//dc.StretchBlt(366, 44, 166, 145, &bg, 0, 0, 256, 224, SRCCOPY);
	//dc.BitBlt(366, 44, 166, 145, &bg, 0, 0, SRCCOPY);

	//bg.SelectObject(bmp_old);

	// Do not call CDialog::OnPaint() for painting messages
}

#define _R(c) (c & 0x000000FF)
#define _G(c) ((c & 0x0000FF00) >> 8)
#define _B(c) ((c & 0x00FF0000) >> 16)

void CEditorEnemyGroupDlg::BlendBGs(CDC *dc, int x, int y, int w, int h)
{
	CWaitCursor cursor;	// Start waiting cursor

	CDC bg[2];

	bg[0].CreateCompatibleDC(dc);
	bg[1].CreateCompatibleDC(dc);

	SelectObject((HDC)bg[0], m_hBG[0]);
	SelectObject((HDC)bg[1], m_hBG[1]);

	if(group.letterbox != 0)
	{
		int cy = 37 + group.letterbox*10;
		bg[0].FillSolidRect(0, 0, 256, cy, 0);
		bg[0].FillSolidRect(0, 224, 256, -cy, 0);
		bg[1].FillSolidRect(0, 0, 256, cy, 0);
		bg[1].FillSolidRect(0, 224, 256, -cy, 0);
	}

	if(!m_bShowBlend)
	{
		dc->BitBlt(x, y, w, h, &bg[m_nLayerShown], 0, 0, SRCCOPY);
		return;
	}
	else
	{
		if(m_nBG[0] == 0)
		{
			dc->BitBlt(x, y, w, h, &bg[1], 0, 0, SRCCOPY);
			return;
		}
		if(m_nBG[1] == 0)
		{
			dc->BitBlt(x, y, w, h, &bg[0], 0, 0, SRCCOPY);
			return;
		}
	}

	dc->BitBlt(x, y, w, h, &bg[m_nLayerShown], 0, 0, SRCCOPY);

	int c1,c2;
	int r,g,b;
	for(int i = 0; i < w; i++)
	{
		for(int j = 0; j < h; j++)
		{
			c2 = bg[1].GetPixel(i,j);
			c1 = bg[0].GetPixel(i,j);

			if(c2 != 0)
			{
				r = _R(c1)/2 + _R(c2);
				g = _G(c1)/2 + _G(c2);
				b = _B(c1)/2 + _B(c2);
			}
			else
			{
				r = _R(c1);
				g = _G(c1);
				b = _B(c1);
			}

			dc->SetPixel(i+x,j+y, RGB(r,g,b));
		}
	}
}


void CEditorEnemyGroupDlg::ChangeBGPreview(int layer, int bg)
{
	char fn[256];
	sprintf(fn, "%s\\bgpreview\\00%d\\%s%s%x.bmp", *curpath, layer, (bg<256)?"0":"", (bg<16)?"0":"", bg);

	HBITMAP temp = (HBITMAP)LoadImage(NULL, fn, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);

	m_nBG[layer] = bg;

	DeleteObject(m_hBG[layer]);

	if(!temp)
	{
		if(bg == 0 || (bg < 0x146 && layer == 0))
			sprintf(fn, "%s\\bgpreview\\blank.bmp", *curpath);
		else
			sprintf(fn, "%s\\bgpreview\\noimg.bmp", *curpath);
	}

	m_hBG[layer] = (HBITMAP)LoadImage(NULL, fn, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);


	DeleteObject(temp);
	delete temp;
}


BOOL CEditorEnemyGroupDlg::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	// TODO: Add your specialized code here and/or call the base class
	NMHDR *hdr = (NMHDR*)lParam;
	int item = (int)wParam;

	switch(hdr->idFrom)
	{
	case IDC_LIST_ENEMIES:

		switch(hdr->code)
		{
		case LVX_LBUTTONDOWN:
			group.enemies[item].num++;
			DisplayData(TRUE, FALSE);
			break;

		case LVX_RBUTTONDOWN:
			group.enemies[item].num--;
			DisplayData(TRUE, FALSE);
			break;

		case LVX_SELCHANGE:
			listbox.SetSelected(group.enemies[item].enemy-1);
			break;
		}
		m_EnemyList.UpdateSubItems();
		break;
	}

	return CDialog::OnNotify(wParam, lParam, pResult);
}



LRESULT CEditorEnemyGroupDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{	switch(message)
	{

	case BM_DRAWITEM:
	{
		if(!Rom->is_loaded)
			return FALSE;

		int item = wParam;
		CDC *dc = (CDC*)lParam;

		CFont font;	// new display font
		font.CreatePointFont(70, "Microsoft Sans Serif");

		CFont *pFntOld = dc->SelectObject(&font);

		Enemy *e = &Rom->enemies[item];

		CString s;

		s.Format("%2d - %s", item, e->name);
		dc->TextOut(40, 2, s);

		s.Format("HP: %d PP: %d", e->hp, e->pp);
		dc->TextOut(40, 17, s);

		s.Format("Exp: %d", e->exp);
		dc->TextOut(40, 28, s);

		// Draw enemy sprite
		CSprite *spr = &Rom->sprites[e->outsidePic];

		dc->FillSolidRect(4, 4, 32, 42, RGB(128,128,128));

		int x = 4 + 16 - (spr->width*4);
		int y = 4 + 21 - (spr->height*4);
		Rom->sprites[e->outsidePic].Draw(dc, x, y, SOUTH|FIRST, Rom);

		dc->SelectObject(pFntOld);
	}
	break;

	}

	return CDialog::WindowProc(message, wParam, lParam);
}



void CEditorEnemyGroupDlg::OnGetdispinfoListEnemies(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;
	// TODO: Add your control notification handler code here

	int item = pDispInfo->item.iItem;
	m_EnemyList.SetItemData(item, group.enemies[item].num);
	m_EnemyList.UpdateSubItems();

	*pResult = 0;
}


void CEditorEnemyGroupDlg::DisplayData(bool change_edit, bool update_preview)
{
	// Disable controls if selected group is group 0
	bool bShowStuff = TRUE;
	if(group.index ==0)
		bShowStuff = FALSE;

	GetDlgItem(IDC_COMBO_LETTERBOX)->EnableWindow(bShowStuff);
	GetDlgItem(IDC_COMBO_USAGE)->EnableWindow(bShowStuff);
	GetDlgItem(IDC_EDIT_FLAG)->EnableWindow(bShowStuff);
	GetDlgItem(IDC_EDIT_BGL1)->EnableWindow(bShowStuff);
	GetDlgItem(IDC_EDIT_BGL2)->EnableWindow(bShowStuff);
	m_EnemyList.EnableWindow(bShowStuff);


	// Set control values
	((CComboBox*)GetDlgItem(IDC_COMBO_LETTERBOX))->SetCurSel(group.letterbox);
	((CComboBox*)GetDlgItem(IDC_COMBO_USAGE))->SetCurSel(group.flaguse);

	if(change_edit)
	{
		update_edit = false;
		SetDlgItemText(IDC_EDIT_FLAG, FormatSNESAdr(group.runflag));
		SetDlgItemText(IDC_EDIT_BGL1, FormatSNESAdr(group.bg1));
		SetDlgItemText(IDC_EDIT_BGL2, FormatSNESAdr(group.bg2));
		update_edit = true;
	}

	GetDlgItem(IDC_RADIO_BGL1)->EnableWindow(!m_bShowBlend);
	GetDlgItem(IDC_RADIO_BGL2)->EnableWindow(!m_bShowBlend);


	// Clear the listbox
	m_EnemyList.DeleteAllItems();


	if(bShowStuff)
	for(int i = 0; i < group.entrycount; i++)
	{
		LVITEM item;
		item.mask = LVIF_TEXT;
		item.iItem = i;
		item.iSubItem = 0;

		char s[256];
		if(group.enemies[i].num == 1)
			sprintf(s, "%s", Rom->enemies[group.enemies[i].enemy-1].name);
		else
			sprintf(s, "%d  %s", group.enemies[i].num, Rom->enemies[group.enemies[i].enemy-1].name);

		item.pszText = s;
		item.lParam = group.enemies[i].num;

		m_EnemyList.InsertItem(&item);
	}


	if(update_preview)
	{
		ChangeBGPreview(0, group.bg1);
		ChangeBGPreview(1, group.bg2);
		Invalidate(FALSE);
	}
}





void CEditorEnemyGroupDlg::SelectGroup(int n)
{
	group = Rom->enemy_groups[n];

	DisplayData();
}

void CEditorEnemyGroupDlg::OnChangeEditBG1() 
{
	if(!update_edit) return;

	CString s;
	GetDlgItemText(IDC_EDIT_BGL1, s);

	unsigned short n = DeformatSNESAdr(s);

	group.bg1 = n;

	DisplayData(FALSE);
}

void CEditorEnemyGroupDlg::OnChangeEditBG2() 
{
	if(!update_edit) return;

	CString s;
	GetDlgItemText(IDC_EDIT_BGL2, s);

	unsigned short n = DeformatSNESAdr(s);

	group.bg2 = n;

	DisplayData(FALSE);
}

void CEditorEnemyGroupDlg::FillGroupList()
{
	for(int i = 0; i < CEnemyBattleGroup::num_entries; i++)
		m_Combo_Group.DeleteString(0);

	char s[1024];

	for(i = 0; i < CEnemyBattleGroup::num_entries; i++)
	{
		Rom->enemy_groups[i].CreateString(s, Rom);
		m_Combo_Group.AddString(s);
	}
}

void CEditorEnemyGroupDlg::OnSelchangeComboGroup() 
{
	// TODO: Add your control notification handler code here
	int n = m_Combo_Group.GetCurSel();

	SelectGroup(n);
}





void CEditorEnemyGroupDlg::OnCheckBlend() 
{
	UpdateData();
	DisplayData();
}

void CEditorEnemyGroupDlg::OnRadioBgl1() 
{
	UpdateData();
	DisplayData();
}

void CEditorEnemyGroupDlg::OnRadioBgl2() 
{
	UpdateData();
	DisplayData();
}

void CEditorEnemyGroupDlg::ApplyChanges()
{
	CString s;

	GetDlgItemText(IDC_EDIT_BGL1, s);
	group.bg1 = DeformatSNESAdr(s);

	GetDlgItemText(IDC_EDIT_BGL2, s);
	group.bg2 = DeformatSNESAdr(s);

	GetDlgItemText(IDC_EDIT_FLAG, s);
	group.runflag = DeformatSNESAdr(s);

	group.flaguse = ((CComboBox*)GetDlgItem(IDC_COMBO_USAGE))->GetCurSel();
	group.letterbox = ((CComboBox*)GetDlgItem(IDC_COMBO_LETTERBOX))->GetCurSel();

	Rom->enemy_groups[group.index] = group;
}

void CEditorEnemyGroupDlg::OnBtnApply() 
{
	// TODO: Add your control notification handler code here
	ApplyChanges();
}

void CEditorEnemyGroupDlg::OnOK() 
{
	// TODO: Add extra validation here
	ApplyChanges();
	CDialog::OnOK();
}

void CEditorEnemyGroupDlg::OnDeltaposSpin1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;

	int n = m_nBG[0] - pNMUpDown->iDelta;

	int nLower,nUpper;
	m_Spin1.GetRange(nLower, nUpper);

	if(n < nLower) n = nLower;
	if(n > nUpper) n = nUpper;

	ChangeBGPreview(0, n);

	SetDlgItemText(IDC_EDIT_BGL1, FormatSNESAdr(n));
	InvalidateRect(CRect(363, 43, 363+256, 43+224), FALSE);

	*pResult = 0;
}

void CEditorEnemyGroupDlg::OnDeltaposSpin2(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;

	int n = m_nBG[1]-pNMUpDown->iDelta;

	int nLower,nUpper;
	m_Spin2.GetRange(nLower, nUpper);

	if(n < nLower) n = nLower;
	if(n > nUpper) n = nUpper;

	ChangeBGPreview(1, n);

	SetDlgItemText(IDC_EDIT_BGL2, FormatSNESAdr(m_nBG[1]));
	InvalidateRect(CRect(363, 43, 363+256, 43+224), FALSE);

	*pResult = 0;
}

void CEditorEnemyGroupDlg::OnBtnSave() 
{
	// TODO: Add your control notification handler code here
	Rom->Save();
}

void CEditorEnemyGroupDlg::OnBtnAdd() 
{
	group.AddEnemy(1, listbox.GetSelected()+1);
	DisplayData(FALSE, FALSE);
}

void CEditorEnemyGroupDlg::OnBtnRem() 
{
	group.DeleteEnemy(m_EnemyList.GetSelectionMark());
	DisplayData(FALSE, FALSE);
}

void CEditorEnemyGroupDlg::OnSelectLetterbox() 
{
	// TODO: Add your control notification handler code here
	group.letterbox = ((CComboBox*)GetDlgItem(IDC_COMBO_LETTERBOX))->GetCurSel();
	DisplayData(FALSE, TRUE);
}
