// EnemyClusterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MapEdit.h"
#include "EnemyClusterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEnemyClusterDlg dialog


CEnemyClusterDlg::CEnemyClusterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEnemyClusterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEnemyClusterDlg)
	//}}AFX_DATA_INIT
	sel_cluster = 0;
}

CEnemyClusterDlg::CEnemyClusterDlg(CRom* pRom, int sel, CWnd* pParent /*=NULL*/)
	: CDialog(CEnemyClusterDlg::IDD, pParent)
{
	Rom = pRom;
	sel_cluster = sel;
}

void CEnemyClusterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEnemyClusterDlg)
	DDX_Control(pDX, IDC_SPINCTRL, m_Spin);
	DDX_Control(pDX, IDC_LIST_SECONDARY, m_ListSecondary);
	DDX_Control(pDX, IDC_LIST_PRIMARY, m_ListPrimary);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEnemyClusterDlg, CDialog)
	//{{AFX_MSG_MAP(CEnemyClusterDlg)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST_PRIMARY, OnGetdispinfoListPrimary)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST_SECONDARY, OnGetdispinfoListSecondary)
	ON_EN_CHANGE(IDC_EDIT_CURENTRY, OnChangeEditCurentry)
	ON_BN_CLICKED(IDC_BTN_ADD1, OnBtnAdd1)
	ON_BN_CLICKED(IDC_BTN_REM1, OnBtnRem1)
	ON_BN_CLICKED(IDC_BTN_ADD2, OnBtnAdd2)
	ON_BN_CLICKED(IDC_BTN_REM2, OnBtnRem2)
	ON_BN_CLICKED(IDC_CHECK_PRIMARY, OnCheckPrimary)
	ON_BN_CLICKED(IDC_CHECK_SECONDARY, OnCheckSecondary)
	ON_BN_CLICKED(ID_BTN_APPLY, OnBtnApply)
	ON_BN_CLICKED(IDC_BTN_EDITGROUPS, OnBtnEditgroups)
	ON_WM_MOUSEWHEEL()
	ON_BN_CLICKED(IDC_BTN_SAVE, OnBtnSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEnemyClusterDlg message handlers

BOOL CEnemyClusterDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	m_ListPrimary.InsertColumn(0, "Enemy groups:", LVCFMT_LEFT, 260, 0);
	m_ListPrimary.InsertColumn(1, "", LVCFMT_LEFT, 0, 0);

	m_ListSecondary.InsertColumn(0, "Enemy Groups", LVCFMT_LEFT, 260, 0);
	m_ListSecondary.InsertColumn(1, "", LVCFMT_LEFT, 0, 0);

	m_Spin.SetRange(0, 202);
	m_Spin.SetBuddy(GetDlgItem(IDC_EDIT_CURENTRY));

	SetDlgItemInt(IDC_EDIT_CURENTRY, sel_cluster);

	SelectCluster(sel_cluster);


	m_GroupList.CreateList(18, 46, 150, 50, 484, 6, this, 0);
	m_GroupList.ShowButtons(FALSE, TRUE);



	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEnemyClusterDlg::OnGetdispinfoListPrimary(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;
	// TODO: Add your control notification handler code here

	int item = pDispInfo->item.iItem;
	m_ListPrimary.SetItemData(item, cluster.primary[item].prb);
	m_ListPrimary.UpdateSubItems();

	*pResult = 0;
}

void CEnemyClusterDlg::OnGetdispinfoListSecondary(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;
	// TODO: Add your control notification handler code here
	int item = pDispInfo->item.iItem;
	m_ListSecondary.SetItemData(item, cluster.secondary[item].prb);
	m_ListSecondary.UpdateSubItems();

	*pResult = 0;
}

BOOL CEnemyClusterDlg::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	// TODO: Add your specialized code here and/or call the base class

	NMHDR *hdr = (NMHDR*)lParam;
	int item = (int)wParam;

	bool checkprb = false;

	switch(hdr->idFrom)
	{
	case IDC_LIST_PRIMARY:
		switch(hdr->code)
		{
		case LVX_LBUTTONDOWN:
			cluster.primary[item].prb++;
			checkprb = true;
			break;

		case LVX_RBUTTONDOWN:
			cluster.primary[item].prb--;
			checkprb = true;
			break;
		case LVX_SELCHANGE:
			m_GroupList.SetSelected(cluster.primary[item].group);
			break;
		}

		m_ListPrimary.UpdateSubItems();
		break;

	case IDC_LIST_SECONDARY:

		switch(hdr->code)
		{
		case LVX_LBUTTONDOWN:
			cluster.secondary[item].prb++;
			checkprb = true;
			break;
		case LVX_RBUTTONDOWN:
			cluster.secondary[item].prb--;
			checkprb = true;
			break;
		case LVX_SELCHANGE:
			m_GroupList.SetSelected(cluster.secondary[item].group);
			break;
		}
		m_ListSecondary.UpdateSubItems();
		break;
	}

	if(checkprb)
	{
		if(cluster.primary[item].prb > 8) cluster.primary[item].prb = 8;
		if(cluster.primary[item].prb < 0) cluster.primary[item].prb = 0;
		if(cluster.secondary[item].prb > 8) cluster.secondary[item].prb = 8;
		if(cluster.secondary[item].prb < 0) cluster.secondary[item].prb = 0;
		UpdateWarningColors();
	}


	return CDialog::OnNotify(wParam, lParam, pResult);
}



void CEnemyClusterDlg::DisplayData()
{
	// Displays data for the current cluster
	CEnemyCluster *c = &cluster;

	// DEBUG
	CString d;
	CString fmt;

/*	for(int x = 0; x < 64; x++)
	{
		unsigned char p = c->data[x];
		fmt.Format("%s%X ", p<16?"0":"",p);
		d+=fmt;
	}

	SetDlgItemText(IDC_EDIT_DEBUG, d);*/
	//SetDlgItemText(IDC_EDIT_ADD, FormatSNESAdr(c->address));

	//CString b1,b2;

	//for(int x = 0; x < 8; x++)
	//{
	//	fmt.Format("%d", (c->p_pri>>(7-x))&1);
	//	b1+=fmt;
	//	fmt.Format("%d", (c->p_sec>>(7-x))&1);
	//	b2+=fmt;
	//}
	//SetDlgItemText(IDC_BITS1, b1);
	//SetDlgItemText(IDC_BITS2, b2);


	SetDlgItemText(IDC_EDIT_FLAG, FormatSNESAdr(c->event));
	SetDlgItemInt(IDC_EDIT_ENCOUNTERPRIMARY, c->p_pri);
	SetDlgItemInt(IDC_EDIT_ENCOUNTERSECONDARY, c->p_sec);

	LVITEM item;

	item.mask = LVIF_TEXT;
	item.iSubItem = 0;

	char s[1024];


	m_ListPrimary.EnableWindow(c->has_primary);
	m_ListSecondary.EnableWindow(c->has_secondary);

	CheckDlgButton(IDC_CHECK_PRIMARY, c->has_primary);
	CheckDlgButton(IDC_CHECK_SECONDARY, c->has_secondary);

	GetDlgItem(IDC_EDIT_ENCOUNTERPRIMARY)->EnableWindow(c->has_primary);
	GetDlgItem(IDC_EDIT_ENCOUNTERSECONDARY)->EnableWindow(c->has_secondary);

	GetDlgItem(IDC_BTN_ADD1)->EnableWindow(c->has_primary);
	GetDlgItem(IDC_BTN_REM1)->EnableWindow(c->has_primary);

	GetDlgItem(IDC_BTN_ADD2)->EnableWindow(c->has_secondary);
	GetDlgItem(IDC_BTN_REM2)->EnableWindow(c->has_secondary);


	m_ListPrimary.DeleteAllItems();
	for(int i = 0; i < c->n_pri; i++)
	{
		item.iItem = i;

		int group = c->primary[i].group;

		if(group < 484) CreateGroupString(group, s);
		else sprintf(s, "Group %d", group);

		item.pszText = s;
		item.lParam = c->primary[i].prb;

		m_ListPrimary.InsertItem(&item);
	}

	m_ListSecondary.DeleteAllItems();
	for(i = 0; i < c->n_sec; i++)
	{
		item.iItem = i;

		int group = c->secondary[i].group;

		if(group < 484) CreateGroupString(group, s);
		else sprintf(s, "Group %d", group);

		item.pszText = s;
		item.lParam = c->secondary[i].prb;

		if(c->secondary[i].prb > 8)
		{
			item.lParam = 8;
			c->secondary[i].prb = 8;
		}

		m_ListSecondary.InsertItem(&item);
	}
	m_ListSecondary.UpdateSubItems();

	UpdateWarningColors();
}



bool CEnemyClusterDlg::ApplyChanges()
{
	// The other data (the groups themselves) are already part of
	// the temp object, so only these two properties need to be
	// retrieved from the controls
	cluster.p_pri = GetDlgItemInt(IDC_EDIT_ENCOUNTERPRIMARY);
	cluster.p_sec = GetDlgItemInt(IDC_EDIT_ENCOUNTERSECONDARY);
	cluster.event = GetDlgItemInt(IDC_EDIT_FLAG);

	int r1 = VerifyPrimaryFreq();
	int r2 = VerifySecondaryFreq();

	bool retval = false;

	if((r1!=0) || (r2!=0))
	{
		CString s;
		char s1[1024] = {0};
		char s2[1024] = {0};

		if(r1!=0) sprintf(s1, "\n001: Primary group frequency does not total eight\n");
		if(r2!=0) sprintf(s1, "\n002: Secondary group frequency does not total eight\n");

		s.Format("Your changes cannot be applied because the following errors occurred:\n%s%s\nThe frequency points can be automatically redistributed and saved for you, or you can go back and correct the problem yourself. Would you like to automatically distrubute points?",
				 s1, s2);

		int result = MessageBox(s, "Error!", MB_YESNO|MB_ICONEXCLAMATION);

		if(result == IDYES)
		{
			// Correct imbalance
			CorrectPrimaryFreq();
			CorrectSecondaryFreq();

			// Don't close window after correction
			// (Give user a chance to view the changes)
			retval = false;
		}

	}
	else
		retval = true;

	Rom->enemy_clusters[cluster.index] = cluster;

	DisplayData();

	return retval;
}




int CEnemyClusterDlg::CreateGroupString(int group, char *s)
{
	return Rom->enemy_groups[group].CreateString(s, Rom);
}

void CEnemyClusterDlg::OnChangeEditCurentry() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here

	int entry = GetDlgItemInt(IDC_EDIT_CURENTRY, NULL, false);

	if(entry < 203)
		SelectCluster(entry);
	else
	{
		SetDlgItemInt(IDC_EDIT_CURENTRY, 202);
	}
}

void CEnemyClusterDlg::SelectCluster(int n)
{
	cluster = Rom->enemy_clusters[n];

	DisplayData();
}





//////////////////////////////////////////////////////////////////////
// Button message handlers

void CEnemyClusterDlg::OnBtnAdd1() 
{
	if(cluster.n_pri < 8)
		cluster.AddGroup(0, 1, m_GroupList.GetSelected());
	else
		MessageBox("You cannot add more than eight groups to a cluster.", "Error!", MB_OK|MB_ICONEXCLAMATION);

	DisplayData();
}

void CEnemyClusterDlg::OnBtnRem1() 
{
	cluster.RemGroup(0, m_ListPrimary.GetSelectionMark());

	DisplayData();
}

void CEnemyClusterDlg::OnBtnAdd2() 
{
	if(cluster.n_sec < 8)
		cluster.AddGroup(1, 1, m_GroupList.GetSelected());
	else
		MessageBox("You cannot add more than eight groups to a cluster.", "Error!", MB_OK|MB_ICONEXCLAMATION);

	DisplayData();
}

void CEnemyClusterDlg::OnBtnRem2() 
{
	cluster.RemGroup(1, m_ListSecondary.GetSelectionMark());

	DisplayData();
}

void CEnemyClusterDlg::OnCheckPrimary() 
{
	cluster.has_primary = IsDlgButtonChecked(IDC_CHECK_PRIMARY)!=0;

	if(!cluster.has_primary)
		cluster.p_pri = 0;

	DisplayData();
}

void CEnemyClusterDlg::OnCheckSecondary() 
{
	cluster.has_secondary = IsDlgButtonChecked(IDC_CHECK_SECONDARY)!=0;

	if(!cluster.has_secondary)
		cluster.p_sec = 0;

	DisplayData();
}

LRESULT CEnemyClusterDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	switch(message)
	{

	case BM_DRAWITEM:
	{
		if(!Rom->is_loaded)
			return FALSE;

		int item = wParam;
		CDC *dc = (CDC*)lParam;

		CFont font;	// new display font
		font.CreatePointFont(70, "Microsoft Sans Serif");

		CFont *pFntOld = dc->SelectObject(&font);

		char buf[1024];
		CreateGroupString(item, buf);

		CString s;

		s.Format("%d", item);
		dc->SetTextAlign(TA_RIGHT);
		dc->TextOut(147, 2, s);
		dc->SetTextAlign(TA_LEFT);


		// Draw some sprites

		CEnemyBattleGroup b = Rom->enemy_groups[item];
		int xoff = 2;

		if(item != 0)
		for(int i = 0; i < b.entrycount; i++)
		{
			int enemy = b.enemies[i].enemy;

			if(enemy == 0) continue;

			Enemy e = Rom->enemies[enemy-1];
			
			int spr = e.outsidePic;

			for(int j = 0; j < b.enemies[i].num; j++)
			{
				Rom->sprites[spr].Draw(dc, 0+xoff, 3, SOUTH|FIRST, Rom);
				//Rom->sprite_gfx[spr].Draw(dc, 0 + xoff, 3, Rom->pal[Rom->sprite_gfx[spr].palette]);
				xoff += Rom->sprites[spr].width*8 + 2;
			}
		}


		s.Format("%s", buf);
		dc->TextOut(3, 37, s);

		dc->SelectObject(pFntOld);
	}
	break;

	}

	return CDialog::WindowProc(message, wParam, lParam);
}



void CEnemyClusterDlg::OnBtnApply() 
{
	// TODO: Add your control notification handler code here
	ApplyChanges();
}



void CEnemyClusterDlg::OnBtnEditgroups() 
{
	// TODO: Add your control notification handler code here
	CEditorEnemyGroupDlg dlg(Rom, m_GroupList.GetSelected(), this);
	dlg.DoModal();
}

int CEnemyClusterDlg::VerifyPrimaryFreq()
{
	if(!cluster.has_primary) return 0;

	int total = 0;
	for(int i = 0; i < cluster.n_pri; i++)
	{
		total+=cluster.primary[i].prb;
	}

	if(total < 8)
		return -1;
	else if(total > 8)
		return 1;
	else
		return 0;
}

int CEnemyClusterDlg::VerifySecondaryFreq()
{
	if(!cluster.has_secondary) return 0;

	int total = 0;
	for(int i = 0; i < cluster.n_sec; i++)
	{
		total+=cluster.secondary[i].prb;
	}

	if(total < 8)
		return -1;
	else if(total > 8)
		return 1;
	else
		return 0;
}

void CEnemyClusterDlg::UpdateWarningColors()
{
	int primary = VerifyPrimaryFreq();
	switch(primary)
	{
	case 1:  m_ListPrimary.SetItemColors(RGB(255,0,0), RGB(128,0,0)); break;
	case 0:  m_ListPrimary.SetItemColors(-1, -1); break;
	case -1: m_ListPrimary.SetItemColors(RGB(0,255,0), RGB(0,128,0)); break;
	}

	int secondary = VerifySecondaryFreq();
	switch(secondary)
	{
	case 1:  m_ListSecondary.SetItemColors(RGB(255,0,0), RGB(128,0,0)); break;
	case 0:  m_ListSecondary.SetItemColors(-1, -1); break;
	case -1: m_ListSecondary.SetItemColors(RGB(0,255,0), RGB(0,128,0)); break;
	}
}

void CEnemyClusterDlg::OnOK() 
{
	// Apply changes and close dialog if everything went fine
	if(ApplyChanges())
		CDialog::OnOK();
}

int CEnemyClusterDlg::CorrectPrimaryFreq()
{
	while(VerifyPrimaryFreq() != 0)
	{
		int t = VerifyPrimaryFreq();

		// find the largest group
		int largest = 0;
		for(int i = 0; i < cluster.n_pri; i++)
		{
			if(cluster.primary[i].prb*t > cluster.primary[largest].prb*t)
				largest = i;
		}
		// decrement its value
		cluster.primary[largest].prb-=t;
	}
	return 1;
}

int CEnemyClusterDlg::CorrectSecondaryFreq()
{
	while(VerifySecondaryFreq() != 0)
	{
		int t = VerifySecondaryFreq();

		// find the largest group (or smallest)
		int largest = 0;
		for(int i = 0; i < cluster.n_sec; i++)
		{
			if(cluster.secondary[i].prb*t > cluster.secondary[largest].prb*t)
				largest = i;
		}
		// decrement (or increment) its value
		cluster.secondary[largest].prb-=t;
	}
	return 1;
}

BOOL CEnemyClusterDlg::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	CRect rect;
	m_GroupList.GetWindowRect(rect);

	if(rect.PtInRect(pt))
	{
		if(zDelta > 0)
			m_GroupList.ScrollBy(-3);
		else
			m_GroupList.ScrollBy(3);
	}

	return CDialog::OnMouseWheel(nFlags, zDelta, pt);
}

void CEnemyClusterDlg::OnBtnSave() 
{
	// TODO: Add your control notification handler code here
	Rom->Save();
}
