#if !defined(AFX_ENEMYCLUSTERDLG_H__BB077F82_5004_46C7_98B5_68191F180CDA__INCLUDED_)
#define AFX_ENEMYCLUSTERDLG_H__BB077F82_5004_46C7_98B5_68191F180CDA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EnemyClusterDlg.h : header file
//

#include "Rom.h"
#include "ListCtrlEx.h"
#include "BoxList.h"

#include "EditorEnemyGroupDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CEnemyClusterDlg dialog

class CEnemyClusterDlg : public CDialog
{
// Construction
public:
	int CorrectSecondaryFreq();
	int CorrectPrimaryFreq();
	void UpdateWarningColors();
	int VerifySecondaryFreq();
	int VerifyPrimaryFreq();
	bool ApplyChanges();
	void SelectCluster(int n);
	int CreateGroupString(int group, char* s);
	void DisplayData();
	CEnemyClusterDlg(CWnd* pParent = NULL);   // standard constructor
	CEnemyClusterDlg(CRom *pRom, int sel, CWnd* pParent = NULL);

	CRom *Rom;	// Pointer to ROM object

	CEnemyCluster cluster;
	int sel_cluster;

	CBoxList m_GroupList;

	// Dialog Data
	//{{AFX_DATA(CEnemyClusterDlg)
	enum { IDD = IDD_ENEMYCLUSTERDLG };
	CSpinButtonCtrl	m_Spin;
	CListCtrlEx	m_ListSecondary;
	CListCtrlEx	m_ListPrimary;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEnemyClusterDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CEnemyClusterDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnGetdispinfoListPrimary(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnGetdispinfoListSecondary(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeEditCurentry();
	afx_msg void OnBtnAdd1();
	afx_msg void OnBtnRem1();
	afx_msg void OnBtnAdd2();
	afx_msg void OnBtnRem2();
	afx_msg void OnCheckPrimary();
	afx_msg void OnCheckSecondary();
	afx_msg void OnBtnApply();
	afx_msg void OnBtnEditgroups();
	virtual void OnOK();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnBtnSave();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ENEMYCLUSTERDLG_H__BB077F82_5004_46C7_98B5_68191F180CDA__INCLUDED_)
