// ListCtrlEx.cpp : implementation file
//

#include "stdafx.h"
#include "List.h"
#include "ListCtrlEx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CListCtrlEx

CListCtrlEx::CListCtrlEx()
{
	m_clrItemColor = RGB(0,128,255);
	m_clrItemShadow = RGB(0,0,128);
}

CListCtrlEx::~CListCtrlEx()
{
}


BEGIN_MESSAGE_MAP(CListCtrlEx, CListCtrl)
	//{{AFX_MSG_MAP(CListCtrlEx)
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_RBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListCtrlEx message handlers


void CListCtrlEx::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	CListCtrl::OnKeyDown(nChar, nRepCnt, nFlags);
}


void CListCtrlEx::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CRect rect;
	int nItems = GetItemCount();
	int nItemClicked = -1;

	for(int i = 0; i < nItems; i++)
	{
		GetItemRect(i, rect, LVIR_BOUNDS);
		rect.OffsetRect(rect.Width(), 0);

		if(rect.PtInRect(point))
		{
			nItemClicked = i;
			SetItemData(i, -1);
			InvalidateRect(rect);
			UpdateSubItems();
		}
	}

	NMHDR hdr;
	hdr.code = LVX_LBUTTONDOWN;
	hdr.hwndFrom = m_hWnd;
	hdr.idFrom = GetDlgCtrlID();

	GetParent()->SendMessage(WM_NOTIFY, nItemClicked, (LPARAM)&hdr);

	CListCtrl::OnLButtonDown(nFlags, point);

	CheckSelection();
}

void CListCtrlEx::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CRect rect;
	int nItems = GetItemCount();
	int nItemClicked = -1;

	for(int i = 0; i < nItems; i++)
	{
		GetItemRect(i, rect, LVIR_BOUNDS);
		rect.OffsetRect(rect.Width(), 0);

		if(rect.PtInRect(point))
		{
			nItemClicked = i;
			SetItemData(i, -1);
			InvalidateRect(rect);
			UpdateSubItems();
		}
	}

	NMHDR hdr;
	hdr.code = LVX_RBUTTONDOWN;
	hdr.hwndFrom = m_hWnd;
	hdr.idFrom = GetDlgCtrlID();

	GetParent()->SendMessage(WM_NOTIFY, nItemClicked, (LPARAM)&hdr);

	CListCtrl::OnRButtonDown(nFlags, point);
}

void CListCtrlEx::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	OnLButtonDown(nFlags, point);
	CListCtrl::OnLButtonDblClk(nFlags, point);

	CheckSelection();
}

void CListCtrlEx::OnRButtonDblClk(UINT nFlags, CPoint point) 
{
	OnRButtonDown(nFlags, point);
	CListCtrl::OnRButtonDblClk(nFlags, point);
}




/////////////////////////////////////////////////////////////////////////////
// Other stuff

void CListCtrlEx::DrawBoxes(int nBox, int x, int y, CDC *dc)
{
	CRect outer;
	outer.left = x-3;
	outer.right = outer.left + 36;
	outer.top = y-2;
	outer.bottom = outer.top + 13;
	
	dc->Draw3dRect(outer, 0, 0);

	for(int i = 0; i < nBox; i++)
	{
		CRect rect;
		rect.left = x + (i*4);
		rect.right = rect.left+2;
		rect.top = y;
		rect.bottom = rect.top+9;

		DrawBox(rect, dc);
	}
}

void CListCtrlEx::DrawBox(CRect rect, CDC *dc)
{
	dc->Draw3dRect(rect, m_clrItemColor, m_clrItemShadow);
}

void CListCtrlEx::UpdateSubItems()
{
	CClientDC dc(this);

	CRect rect;

	int nItems = GetItemCount();

	for(int i = 0; i < nItems; i++)
	{
		GetItemRect(i, rect, LVIR_BOUNDS);
		DrawBoxes(GetItemData(i), rect.right+4, rect.top+2, &dc);
	}
}


void CListCtrlEx::SetItemColors(int rgbColor, int rgbShadow)
{
	if(rgbColor != -1) m_clrItemColor = rgbColor;
	else m_clrItemColor = RGB(0,128,255);

	if(rgbShadow != -1) m_clrItemShadow = rgbShadow;
	else m_clrItemShadow = RGB(0,0,128);

	Invalidate(FALSE);
}

void CListCtrlEx::CheckSelection()
{
	int n = GetSelectionMark();

	if(n != -1)
	{
		m_nOldSel = n;

		NMHDR hdr;
		hdr.code = LVX_SELCHANGE;
		hdr.hwndFrom = m_hWnd;
		hdr.idFrom = GetDlgCtrlID();

		GetParent()->SendMessage(WM_NOTIFY, n, (LPARAM)&hdr);
	}

}
