// SectorPropWnd.cpp : implementation file
//

#include "stdafx.h"
#include "MapEdit.h"
#include "SectorPropWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSectorPropWnd dialog


CSectorPropWnd::CSectorPropWnd(CWnd* pParent /*=NULL*/)
	: CDialog(CSectorPropWnd::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSectorPropWnd)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSectorPropWnd::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSectorPropWnd)
	DDX_Control(pDX, IDC_COMBO_TOWNMAP, m_Combo_Map);
	DDX_Control(pDX, IDC_COMBO_SPECIAL, m_Combo_Special);
	DDX_Control(pDX, IDC_COMBO_ITEM, m_Combo_Item);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSectorPropWnd, CDialog)
	//{{AFX_MSG_MAP(CSectorPropWnd)
	ON_BN_CLICKED(IDC_CHECK_TELEPORT, OnCheckTeleport)
	ON_CBN_SELCHANGE(IDC_COMBO_ITEM, OnSelchangeItem)
	ON_CBN_SELCHANGE(IDC_COMBO_SPECIAL, OnSelchangeSpecial)
	ON_CBN_SELCHANGE(IDC_COMBO_TOWNMAP, OnSelchangeTownmap)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSectorPropWnd message handlers

BOOL CSectorPropWnd::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	font.CreatePointFont(75, "Microsoft Sans Serif");

	m_Combo_Item.SetFont(&font);
	m_Combo_Map.SetFont(&font);
	m_Combo_Special.SetFont(&font);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSectorPropWnd::SetSectorFlags(unsigned short sFlags)
{
	m_sFlags = sFlags;
	DisplayData();
}

unsigned short CSectorPropWnd::GetSectorFlags()
{
	return m_sFlags;
}

void CSectorPropWnd::DisplayData()
{
	// Teleport enabled
	CheckDlgButton(IDC_CHECK_TELEPORT, !(m_sFlags&0x80));

	// Town map
	unsigned char map = 0;

	map += (m_sFlags & 0x20) >> 3;
	map += (m_sFlags & 0x10) >> 3;
	map += (m_sFlags & 0x08) >> 3;

	m_Combo_Map.SetCurSel(map);


	// Sector properties
	unsigned char prop = 0;

	prop += (m_sFlags & 0x4);// << 2;
	prop += (m_sFlags & 0x2);// << 1;
	prop += (m_sFlags & 0x1);// << 0;

	m_Combo_Special.SetCurSel(prop);


	// Item
	unsigned char item;

	item = (m_sFlags & 0xFF00) >> 8;

	for(int i = 0; i < m_Combo_Item.GetCount(); i++)
	{
		if(m_Combo_Item.GetItemData(i) == item)
		{
			m_Combo_Item.SetCurSel(i);
		}
	}
}

void CSectorPropWnd::InitItemBox(CRom *pRom)
{
	while(m_Combo_Item.DeleteString(0));

	m_Combo_Item.InsertString(0,"***--Type-58 items--***");
	m_Combo_Item.SetItemData(0,-1);

	int count = 1;

	for(int i = 0; i < 254; i++)
	{
		if(pRom->items[i].type == 58 || i == 0)
		{
			CString s;
			s.Format("%d - %s", i, pRom->items[i].name);

			m_Combo_Item.InsertString(count,s);
			m_Combo_Item.SetItemData(count, i);

			count++;
		}
	}
	m_Combo_Item.InsertString(count, "");
	m_Combo_Item.SetItemData(count++, -1);
	m_Combo_Item.InsertString(count,"***--Other items--***");
	m_Combo_Item.SetItemData(count++,-1);

	for(i = 1; i < 254; i++)
	{
		if(pRom->items[i].type != 58)
		{
			CString s;
			s.Format("%s", pRom->items[i].name);

			m_Combo_Item.InsertString(count, s);
			m_Combo_Item.SetItemData(count++,i);
		}
	}
}

void CSectorPropWnd::Enable(bool bEnable)
{
	GetDlgItem(IDC_CHECK_TELEPORT)->EnableWindow(bEnable);
	m_Combo_Item.EnableWindow(bEnable);
	m_Combo_Special.EnableWindow(bEnable);
	m_Combo_Map.EnableWindow(bEnable);
}

void CSectorPropWnd::OnCheckTeleport() 
{
	bool bOn = IsDlgButtonChecked(IDC_CHECK_TELEPORT)!=0;

	m_sFlags ^= 0x80;

	GetParent()->SendMessage(SP_CHANGE);
}

void CSectorPropWnd::OnSelchangeItem() 
{
	//int n = m_Combo_Item.GetCurSel();
	while(m_Combo_Item.GetItemData(m_Combo_Item.GetCurSel())==-1)
		m_Combo_Item.SetCurSel(m_Combo_Item.GetCurSel()+1);

	int n = m_Combo_Item.GetItemData(m_Combo_Item.GetCurSel());
	
	m_sFlags &= 0x00FF;
	m_sFlags |= n << 8;

	GetParent()->SendMessage(SP_CHANGE);
}

void CSectorPropWnd::OnSelchangeSpecial() 
{
	int n = m_Combo_Special.GetCurSel();

	m_sFlags &= 0xFFF8;
	m_sFlags |= n;

	GetParent()->SendMessage(SP_CHANGE);
}

void CSectorPropWnd::OnSelchangeTownmap() 
{
	int n = m_Combo_Map.GetCurSel();

	m_sFlags &= 0xFFC7;
	m_sFlags |= n << 3;

	GetParent()->SendMessage(SP_CHANGE);
}


