// SpriteDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MapEdit.h"
#include "SpriteDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSpriteDlg dialog


CSpriteDlg::CSpriteDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSpriteDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSpriteDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CSpriteDlg::CSpriteDlg(int area, int sprite, CWnd* pParent /*=NULL*/)
	: CDialog(CSpriteDlg::IDD, pParent)
{
	this->n_area = area;
	this->n_sprite = sprite;
}

void CSpriteDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSpriteDlg)
	DDX_Control(pDX, IDC_SELECT_USAGE, m_Combo_Usage);
	DDX_Control(pDX, IDC_COMBO_ITEM, m_ItemList);
	DDX_Control(pDX, IDC_SPIN_SPR, m_Spin);
	DDX_Control(pDX, IDC_COMBO_TYPE, m_Combo_Type);
	DDX_Control(pDX, IDC_COMBO_DIR, m_Combo_Dir);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSpriteDlg, CDialog)
	//{{AFX_MSG_MAP(CSpriteDlg)
	ON_WM_PAINT()
	ON_EN_CHANGE(IDC_EDIT_SPRITE, OnChangeEditSprite)
	ON_EN_CHANGE(IDC_EDIT_TPTNUM, OnChangeEditTptNum)
	ON_BN_CLICKED(IDC_APPLY_TPT, OnApplyTPT)
	ON_CBN_SELCHANGE(IDC_COMBO_TYPE, OnSelectType)
	ON_CBN_SELCHANGE(IDC_COMBO_DIR, OnSelectDir)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSpriteDlg message handlers

BOOL CSpriteDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	for(int i = 0; i < 1583; i++)
		tpt[i] = Rom->tpt[i];

	char s[256];
	for(i = 0; i < 254; i++)
	{
		sprintf(s, "%s - [%d]", Rom->items[i].name, i);
		m_ItemList.InsertString(i, s);
	}


	sprite = Rom->object_areas[n_area].sprites[n_sprite];
	
	// TODO: Add extra initialization here
	DisplaySpriteData();

	SetDlgItemInt(IDC_EDIT_TPTNUM, sprite.tptNum);

	m_Spin.SetRange(0, 463);
	m_Spin.SetPos(tpt[sprite.tptNum].sprite);

	m_Spin.SetBuddy(GetDlgItem(IDC_EDIT_SPRITE));



	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSpriteDlg::DisplaySpriteData()
{
	if(!user_edited)
		SetDlgItemInt(IDC_EDIT_TPTNUM, sprite.tptNum);
	
	CString str;
	str.Format("TPT Entry Information: entry #%d", sprite.tptNum);
	SetDlgItemText(IDC_GROUPBOX, str);

	SetDlgItemInt(IDC_EDIT_X, sprite.x);
	SetDlgItemInt(IDC_EDIT_Y, sprite.y);

	SetDlgItemInt(IDC_EDIT_SPRITE, tpt[sprite.tptNum].sprite);
	SetDlgItemText(IDC_EDIT_POINTER, FormatSNESAdr(tpt[sprite.tptNum].pointer));
	SetDlgItemText(IDC_EDIT_ITEMPOINTER, FormatSNESAdr(tpt[sprite.tptNum].itempointer));
	SetDlgItemText(IDC_EDIT_FLAG, FormatSNESAdr(tpt[sprite.tptNum].flag));

	m_Combo_Usage.SetCurSel(tpt[sprite.tptNum].flaguse);
	//SetDlgItemInt(IDC_EDIT_FLAGUSE, tpt[sprite.tptNum].flaguse);

	SetDlgItemInt(IDC_EDIT_MOVEMENT1, tpt[sprite.tptNum].movement1);
	SetDlgItemInt(IDC_EDIT_MOVEMENT2, tpt[sprite.tptNum].movement2);

	m_ItemList.SetCurSel(tpt[sprite.tptNum].item);

	m_Combo_Dir.SetCurSel(tpt[sprite.tptNum].dir);
	m_Combo_Type.SetCurSel(tpt[sprite.tptNum].type-1);

	if(tpt[sprite.tptNum].type == 2) {
		GetDlgItem(IDC_EDIT_ITEMPOINTER)->EnableWindow(FALSE);
		GetDlgItem(IDC_SELECT_ITEM)->EnableWindow(TRUE);
	}
	else {
		GetDlgItem(IDC_EDIT_ITEMPOINTER)->EnableWindow(TRUE);
		GetDlgItem(IDC_SELECT_ITEM)->EnableWindow(FALSE);
	}
}

void CSpriteDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here

	int spr = tpt[sprite.tptNum].sprite;

	//CSprite *sprite = &Rom->sprites[spr];

	int x = 27;
	int y = 100;

	int w = Rom->sprites[spr].width * 8;
	int h = Rom->sprites[spr].height * 8;

	dc.FillSolidRect(27, 100, 64, 80, GetSysColor(COLOR_3DSHADOW));

	//Rom->sprite_gfx[spr].Draw(&dc, 27 + 32-(w/2), 100 + 40-(h/2), Rom->pal[Rom->sprite_gfx[spr].palette], m_Combo_Dir.GetCurSel() == 1);

	int dir = m_Combo_Dir.GetCurSel();
	switch(dir)
	{
	case 0: dir = NORTH; break;
	case 1: dir = EAST; break;
	case 2: dir = SOUTH; break;
	case 3: dir = WEST; break;
	default: dir = SOUTH; break;
	}

	CString s;
	s.Format("W:%d H:%d Pal:%d", Rom->sprites[spr].width, Rom->sprites[spr].height, Rom->sprites[spr].palette);
	dc.TextOut(0, 0, s);

	int p = Rom->sprites[spr].palette;
	Rom->pal[p].Draw(&dc, 3, 14);


	Rom->sprites[spr].Draw(&dc, 27+32-(w/2), 100+40-(h/2), dir, Rom);
	// Do not call CDialog::OnPaint() for painting messages
}

void CSpriteDlg::OnChangeEditSprite() 
{
	int spr = GetDlgItemInt(IDC_EDIT_SPRITE);

	if(spr < 464) {
		tpt[sprite.tptNum].sprite = spr;
		Invalidate(FALSE);
	}
}

void CSpriteDlg::ApplyChanges()
{
	// Get data from controls
	sprite.tptNum = GetDlgItemInt(IDC_EDIT_TPTNUM);
	sprite.x = GetDlgItemInt(IDC_EDIT_X);
	sprite.y = GetDlgItemInt(IDC_EDIT_Y);

	// Copy data to ROM
	Rom->object_areas[n_area].sprites[n_sprite] = sprite;
}

void CSpriteDlg::ApplyTPTChanges()
{
	int i = sprite.tptNum;

	tpt[i].sprite = GetDlgItemInt(IDC_EDIT_SPRITE);

	CString str;

	GetDlgItemText(IDC_EDIT_POINTER, str);
	tpt[i].pointer = DeformatSNESAdr(str);

	GetDlgItemText(IDC_EDIT_ITEMPOINTER, str);
	tpt[i].itempointer = DeformatSNESAdr(str);

	GetDlgItemText(IDC_EDIT_FLAG, str);
	tpt[i].flag = DeformatSNESAdr(str);
	tpt[i].flaguse = m_Combo_Usage.GetCurSel();

	tpt[i].movement1 = GetDlgItemInt(IDC_EDIT_MOVEMENT1);
	tpt[i].movement2 = GetDlgItemInt(IDC_EDIT_MOVEMENT2);

	tpt[i].item = m_ItemList.GetCurSel();//GetDlgItemInt(IDC_EDIT_ITEM);

	tpt[i].dir = m_Combo_Dir.GetCurSel();
	tpt[i].type = m_Combo_Type.GetCurSel()+1;
}


void CSpriteDlg::OnChangeEditTptNum() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	int tptnum = GetDlgItemInt(IDC_EDIT_TPTNUM);
	if(tptnum < 1583) {
		sprite.tptNum = tptnum;

		user_edited = TRUE;
		DisplaySpriteData();
		user_edited = FALSE;
	}
}

void CSpriteDlg::OnApplyTPT() 
{
	ApplyTPTChanges();
}

void CSpriteDlg::OnOK() 
{
	ApplyChanges();
	ApplyTPTChanges();

	// copy local TPT copy to ROM

	for(int i = 0; i < 1583; i++)
		Rom->tpt[i] = tpt[i];

	CDialog::OnOK();
}

void CSpriteDlg::OnSelectType() 
{
	tpt[sprite.tptNum].type = m_Combo_Type.GetCurSel()+1;
	DisplaySpriteData();
}

void CSpriteDlg::OnSelectDir() 
{
	// TODO: Add your control notification handler code here
	Invalidate(FALSE);
}
