// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#include "ToolboxBar.h"
#include "StatusBarEx.h"

#if !defined(AFX_MAINFRM_H__233B6820_D4C0_4682_A69E_0FB35E8A20F1__INCLUDED_)
#define AFX_MAINFRM_H__233B6820_D4C0_4682_A69E_0FB35E8A20F1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CMainFrame : public CFrameWnd
{
	
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL DestroyWindow();
	virtual void RecalcLayout(BOOL bNotify = TRUE);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	void CloseFile();
	void LoadFile(CString szFilename);
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:  // control bar embedded members
	void UpdateStatusBar();
	void SeekProc(bool is_starting, bool from_doordlg, bool set_val, int destindex, int x, int y);
	void ReturnFromDestSeek();
	void OpenDestinationDlg(int nDest, bool from_doordlg = FALSE, bool set_val = FALSE, int x = -1, int y = -1);
	void OpenDoorDlg(int nArea, int nDoor);
	BOOL IsDoorSeeking();
	int GetEditMode();
	void SwitchEditMode(int nMode, BOOL bRedraw=TRUE);
	CStatusBarEx  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	CReBar      m_wndReBar;
	CDialogBar  m_wndDlgBar;
	CToolBox	m_wndToolboxBar;


// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnFileOpen();
	afx_msg void OnSelectTileset();
	afx_msg void OnEditX();
	afx_msg void OnEditY();
	afx_msg void OnEditPalette();
	afx_msg void OnEditMusic();
	afx_msg void OnViewGridlines();
	afx_msg void OnUpdateViewGridlines(CCmdUI* pCmdUI);
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnEditUndo();
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnFileClose();
	afx_msg void OnUpdateFileClose(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	afx_msg void OnToolsDestination();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnModeDoor();
	afx_msg void OnUpdateModeDoor(CCmdUI* pCmdUI);
	afx_msg void OnModeMap();
	afx_msg void OnUpdateModeMap(CCmdUI* pCmdUI);
	afx_msg void OnModeSprite();
	afx_msg void OnUpdateModeSprite(CCmdUI* pCmdUI);
	afx_msg void OnToolsAddDoor();
	afx_msg void OnUpdateToolsAddDoor(CCmdUI* pCmdUI);
	afx_msg void OnUpdateToolsDestinationEdit(CCmdUI* pCmdUI);
	afx_msg void OnToolsAddSprite();
	afx_msg void OnUpdateToolsAddSprite(CCmdUI* pCmdUI);
	afx_msg void OnViewSpriteborders();
	afx_msg void OnUpdateViewSpriteborders(CCmdUI* pCmdUI);
	afx_msg void OnViewSpriteOutlines();
	afx_msg void OnUpdateViewSpriteOutlines(CCmdUI* pCmdUI);
	afx_msg void OnViewDragSpriteOutline();
	afx_msg void OnUpdateViewDragSpriteOutline(CCmdUI* pCmdUI);
	afx_msg void OnViewBorderFlash();
	afx_msg void OnUpdateViewBorderFlash(CCmdUI* pCmdUI);
	afx_msg void OnToolsRemoveObject();
	afx_msg void OnUpdateToolsRemoveObject(CCmdUI* pCmdUI);
	afx_msg void OnToolsTPTEditor();
	afx_msg void OnUpdateToolsTPTEditor(CCmdUI* pCmdUI);
	afx_msg void OnToolsAddladder();
	afx_msg void OnUpdateToolsAddladder(CCmdUI* pCmdUI);
	afx_msg void OnToolsAddrope();
	afx_msg void OnUpdateToolsAddrope(CCmdUI* pCmdUI);
	afx_msg void OnToolsMusicEditor();
	afx_msg void OnUpdateToolsMusicEditor(CCmdUI* pCmdUI);
	afx_msg void OnViewToolBox();
	afx_msg void OnUpdateViewToolBox(CCmdUI* pCmdUI);
	afx_msg void OnViewAttributeBar();
	afx_msg void OnUpdateViewAttributeBar(CCmdUI* pCmdUI);
	afx_msg void OnViewSelectedInfo();
	afx_msg void OnUpdateViewSelectedInfo(CCmdUI* pCmdUI);
	afx_msg void OnEditRepeat();
	afx_msg void OnUpdateEditRepeat(CCmdUI* pCmdUI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnModeEnemy();
	afx_msg void OnUpdateModeEnemy(CCmdUI* pCmdUI);
	afx_msg void OnHelpTest();
	afx_msg void OnToolsEnemycluster();
	afx_msg void OnUpdateToolsEnemycluster(CCmdUI* pCmdUI);
	afx_msg void OnToolsPaletteeditor();
	afx_msg void OnUpdateToolsPaletteeditor(CCmdUI* pCmdUI);
	afx_msg void OnViewZoom100();
	afx_msg void OnUpdateViewZoom100(CCmdUI* pCmdUI);
	afx_msg void OnViewZoom150();
	afx_msg void OnUpdateViewZoom150(CCmdUI* pCmdUI);
	afx_msg void OnViewZoom200();
	afx_msg void OnUpdateViewZoom200(CCmdUI* pCmdUI);
	afx_msg void OnViewZoom300();
	afx_msg void OnUpdateViewZoom300(CCmdUI* pCmdUI);
	afx_msg void OnToolsEnemygroupeditor();
	afx_msg void OnUpdateToolsEnemygroupeditor(CCmdUI* pCmdUI);
	afx_msg void OnFunstuffMuzak();
	afx_msg void OnUpdateFunstuffMuzak(CCmdUI* pCmdUI);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnSizing(UINT fwSide, LPRECT pRect);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__233B6820_D4C0_4682_A69E_0FB35E8A20F1__INCLUDED_)
