// MapEditView.h : interface of the CMapEditView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAPEDITVIEW_H__9B6A0EBD_0FBB_4154_A281_49F5D833C2A8__INCLUDED_)
#define AFX_MAPEDITVIEW_H__9B6A0EBD_0FBB_4154_A281_49F5D833C2A8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CMapEditView : public CScrollView
{
protected: // create from serialization only
	CMapEditView();
	DECLARE_DYNCREATE(CMapEditView)

// Attributes
public:
	CMapEditDoc* GetDocument();

	CDC lastview;	// buffer for last map view
	//CDC mapbuf;		// secondary buffer for view buffering operations

	CToolBox* m_pToolbox;		// Pointer to app toolbar
	// the view needs a pointer to the application's toolbar
	// (which belongs to the frame) so it can access the stuff
	// it needs when the user draws map tiles, et cetera.


	// cursors
	HCURSOR m_hcrArrow;

	HCURSOR m_hcrDropper;
	HCURSOR m_hcrQuestion;
	HCURSOR m_hcrAdd;
	HCURSOR m_hcrCopy;

	HCURSOR m_hcrHand;
	HCURSOR m_hcrNohand;
	HCURSOR m_hcrNono;


	// key press flags
	bool KEYSCROLL_L;
	bool KEYSCROLL_R;
	bool KEYSCROLL_U;
	bool KEYSCROLL_D;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMapEditView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	float GetZoomLevel();
	void ResizeScrollbars();
	void SetZoomLevel(float zoom);
	int GetTileHeight();
	int GetTileWidth();
	CSize GetScrollOffset();
	CPoint GetMousePos();
	int GetVertOffset();
	int GetHorzOffset();
	void ScrollToDestination(DestinationEntry dest);
	void PlaceTile(int x, int y, int tile);
	int AddPt(CPoint pt, CPoint pt_list[], int len);
	BOOL CheckPt(CPoint pt, int set, CPoint pt_list[], int &len);

	void SelectAdjacentSectors(int x, int y);
	void DrawTile(HDC dc, int cx, int cy, int set, int tile, int palette);
	void ShowInfo();
	void ScrollTo(int x, int y);
	void SelectSector(int x, int y, bool newSelection = FALSE, bool redraw = TRUE);
	virtual ~CMapEditView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMapEditView)
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MapEditView.cpp
inline CMapEditDoc* CMapEditView::GetDocument()
   { return (CMapEditDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAPEDITVIEW_H__9B6A0EBD_0FBB_4154_A281_49F5D833C2A8__INCLUDED_)
