//////////////////////////////////////////////////////////////////////////////////////////////
// Audio.CPP:
//

#include <allegro.h>
//#include <windef.h>
//#include <winbase.h>
//#include <mmsystem.h>
#include <stdlib.h>
#include <stdio.h>

//#include "types.h"
//#include "snesapu.h"

#include "spcplay.h"



/*
//**************************************************************************************************
// Variables and Data

typedef struct
{
	u8	pc[2];
	u8	a;
	u8	x;
	u8	y;
	u8	psw;
	u8	sp;
} SPCReg;

//SPC header structure
typedef struct
{
	s8		fTag[33];							//File tag
	s8		tTerm[3];							//Tag terminator
	s8		ver;								//Version #/100
	SPCReg	reg;								//SPC Registers
	u16		__r1;
	s8		song[32];							//Song title
	s8		game[32];							//Game title
	s8		dumper[16];							//Name of dumper
	s8		comment[32];						//Comments
	s8		date[11];							//Date dumped
	s8		songLen[3];							//Song length (# of seconds to play before fading)
	s8		fadeLen[5];							//Fade length (milliseconds)
	s8		artist[32];							//Artist of song
	u8		chnDis;								//Channel Disabled?
	u8		emulator;							//Emulator dumped with
	u8		__r2[45];
} SPCHdr;

typedef struct
{
	SPCHdr	hdr;
	u8		ram[0x10000];
	DSPReg	dsp;
	u8		_r[0x40];
	u8		xram[0x40];
} SPCFile;

typedef struct
{
	HWAVEOUT		handle;						//Handle to output device
	tWAVEFORMATEX	fmt;						//Format of sample data being sent
	WAVEHDR			hdr[2];						//Headers for two buffers
} WavOut;


WAVEHDR *tempwav;
bool update_waveout = true;


SAPUFunc		apu;	//** Ah, so these are the pointers to the SAPU functions
s8				fn[MAX_PATH]; //** probably filename
SPCFile			spc;		// instance of wrapper for SPC file?
s8				dllVer[32];	// DLL version?

WavOut	wav;
b8		is_open;									//Output device is open
void	*pBuf;									//-> memory allocated for sample data
u32		bufSize;								//Size of single output buffer


HWND window;


//**************************************************************************************************
// Functions

s32		CALLBACK MessageProc(HWND hwnd, UINT umsg, WPARAM wparam, LPARAM lparam);
b8		OpenFile(HWND hwnd);
void	WavInit();
void	WavQuit();
b8		WavOpen();
void	WavClose();



//**************************************************************************************************
// Power of 2 function

f64 Pow2(f64 exp)
{
#ifdef	__GNUC__
	f80	ret;


	asm("
		f2xm1
		fld1
		faddp	%%st,%%st(1)

	" : "=t" (ret) : "0" (exp));

	return ret;
#else
	_asm
	{
		fld		[exp]
		f2xm1
		fld1
		faddp	st(1),st
	}
#endif
}
*/


	CSPCPlayer player;
char* filename = "C:\\Stuff\\SNES GAMES\\evermore.spc";//C:\\Stuff\\ZSNES\\ct.spc";


void close_hook()
{
	// simulate 'escape' key pressed to close application
	key[KEY_ESC] = true;
	return;
}

void switch_in()
{
	// resume music
	//waveOutRestart(wav.handle);
	player.Play();
}

void switch_out()
{
	// pause music
	//waveOutPause(wav.handle);
	player.Pause();
}


int main(int argc, char* argv[])
{
	allegro_init();
	install_timer();
	install_keyboard();

	install_sound(DIGI_AUTODETECT, MIDI_NONE, "");

	set_color_depth(16);
	set_gfx_mode(GFX_AUTODETECT_WINDOWED, 400, 200, 0, 0);
	//set_display_switch_mode(SWITCH_BACKGROUND);

	set_display_switch_callback(SWITCH_IN, switch_in);
	set_display_switch_callback(SWITCH_OUT, switch_out);

	BITMAP* buffer = create_bitmap(400, 200);
	clear_bitmap(buffer);

	set_window_close_hook(close_hook);


	if(argc > 1)
		filename = argv[1];


/*
	HINSTANCE	hDLL;
	u32			ver,min,opt;


	//==========================================
	// Load SNESAPU.DLL

	hDLL = LoadLibrary("SNESAPU.DLL");			//Try to load SNESAPU
	if (hDLL)
	{
		*(void**)&apu.SNESAPUInfo = (void*)GetProcAddress(hDLL,"SNESAPUInfo");
		apu.SNESAPUInfo(&ver, &min, &opt);

		sprintf(dllVer, "SNESAPU.DLL v%x.%x%c", ver >> 16, (ver >> 8) & 0xFF, ver & 0xFF);
	}
	else
	{
		allegro_message("Could not load SNESAPU.DLL");
		return -1;
	}

	//Get pointers to needed functions ---------
	*(void**)&apu.GetAPUData	= (void*)GetProcAddress(hDLL,"GetAPUData");
	*(void**)&apu.ResetAPU		= (void*)GetProcAddress(hDLL,"ResetAPU");
	*(void**)&apu.FixAPU		= (void*)GetProcAddress(hDLL,"FixAPU");
//	*(void**)&apu.SaveAPU		= (void*)GetProcAddress(hDLL,"SaveAPU");
//	*(void**)&apu.RestoreAPU	= (void*)GetProcAddress(hDLL,"RestoreAPU");
	*(void**)&apu.SetAPUOpt		= (void*)GetProcAddress(hDLL,"SetAPUOpt");
	*(void**)&apu.SetAPUSmpClk	= (void*)GetProcAddress(hDLL,"SetAPUSmpClk");
//	*(void**)&apu.SetAPULength	= (void*)GetProcAddress(hDLL,"SetAPULength");
//	*(void**)&apu.SetAPURAM		= (void*)GetProcAddress(hDLL,"SetAPURAM");
	*(void**)&apu.EmuAPU		= (void*)GetProcAddress(hDLL,"EmuAPU");
//	*(void**)&apu.SeekAPU		= (void*)GetProcAddress(hDLL,"SeekAPU");
//	*(void**)&apu.SetSPCDbg		= (void*)GetProcAddress(hDLL,"SetSPCDbg");
//	*(void**)&apu.GetSPCRegs	= (void*)GetProcAddress(hDLL,"GetSPCRegs");
//	*(void**)&apu.InPort		= (void*)GetProcAddress(hDLL,"InPort");
//	*(void**)&apu.InPortW		= (void*)GetProcAddress(hDLL,"InPortW");
//	*(void**)&apu.EmuSPC		= (void*)GetProcAddress(hDLL,"EmuSPC");
//	*(void**)&apu.SetDSPDbg		= (void*)GetProcAddress(hDLL,"SetDSPDbg");
//	*(void**)&apu.SetDSPReg		= (void*)GetProcAddress(hDLL,"SetDSPReg");
//	*(void**)&apu.SetDSPPitch	= (void*)GetProcAddress(hDLL,"SetDSPPitch");
//	*(void**)&apu.SetDSPAmp		= (void*)GetProcAddress(hDLL,"SetDSPAmp");
//	*(void**)&apu.SetDSPStereo	= (void*)GetProcAddress(hDLL,"SetDSPStereo");
//	*(void**)&apu.SetDSPEFBCT	= (void*)GetProcAddress(hDLL,"SetDSPEFBCT");
//	*(void**)&apu.EmuDSP		= (void*)GetProcAddress(hDLL,"EmuDSP");
//	*(void**)&apu.PlayWave		= (void*)GetProcAddress(hDLL,"PlayWave");
//	*(void**)&apu.UnpackWave	= (void*)GetProcAddress(hDLL,"UnpackWave");
//	*(void**)&apu.PackWave		= (void*)GetProcAddress(hDLL,"PackWave");
//	*(void**)&apu.VMax2dB		= (void*)GetProcAddress(hDLL,"VMax2dB");

	apu.GetAPUData(&apu.ram, &apu.xram, &apu.outPort, &apu.t64Cnt,
				   &apu.dsp, &apu.voice, &apu.vMMaxL, &apu.vMMaxR);


	WavInit();

	//==========================================
	// Main Window

	//DialogBox(hinst, MAKEINTRESOURCE(DLG_MAIN), NULL, MessageProc);


	//*** INSERT PROGRAM LOOP HERE *** //




	//***LOAD FILE*** //
	HANDLE fh;
	DWORD l;
	fh = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	ReadFile(fh, &spc, sizeof(spc), &l, NULL);
	CloseHandle(fh);


	//***INIT APU***-//
	apu.ResetAPU(0x20000);					//Reset APU

	// Set APU options (needs to be called because current build
	// of SNESAPU.dll incorrectly initializes emulation speed)
	//apu.SetAPUOpt(-1, 2, 8, 32000, -1, -1);
	apu.SetAPUOpt(-1, 2, 16, 32000, -1, -1);

	//apu.SetAPUSmpClk(Pow2(24 / 48.0) * 65536.0);

	memcpy(apu.ram, spc.ram, 0x10000);		//Copy SPC to APU emulator
	memcpy(apu.xram, spc.xram, 0x40);
	memcpy(apu.dsp, &spc.dsp, 0x80);

	apu.FixAPU(*(u16*)spc.hdr.reg.pc,		//Fix up APU after loading an SPC
				spc.hdr.reg.a, spc.hdr.reg.x, spc.hdr.reg.y,
				spc.hdr.reg.psw,
				spc.hdr.reg.sp);
*/

	//***BEGIN PLAYING*** //



	player.Init();

	player.Load(filename);
	//player.Load("C:\\Allegro\\Projects\\Audio\\Singing Mountain.spc");

	player.Play();

	//if (!player.WavOpen())
	//{
	//	allegro_message("Error opening audio device!");
	//}


	//AUDIOSTREAM* stream = play_audio_stream(1024, 8, 1, 32000, 255, 128);



	//CSPCPlayer spc;
	//Init();

	//Load(filename);

	//Play();

	int nSecs = 0;

	// loop/display until user quits
	while(!key[KEY_ESC])
	{
		//* check for audio stream buffer thing
		//  and do sound stuff here: */
		///unsigned char *p = (unsigned char*)get_audio_stream_buffer(stream);

		//if(p)
		//{
		//	apu.EmuAPU(p, 1024, true);
		//	free_audio_stream_buffer(stream);
		//}
		//**//


		acquire_screen();
		acquire_bitmap(buffer);

		textprintf(buffer, font, 10, 10, makecol(255,255,255), "%s", filename);
		//textprintf(buffer, font, 10, 25, makecol(255,255,255), "Playing: %d.%d seconds", nSecs/10, nSecs-(int(nSecs/10)*10));
		blit(buffer, screen, 0, 0, 0, 0, 400, 200);

		release_bitmap(buffer);
		release_screen();


		//rest(100);
		//nSecs++;
	}

	//stop_audio_stream(stream);



	//Free everything --------------------------
	//WavQuit();
	//FreeLibrary(hDLL);


	return 0;
}
END_OF_MAIN();














/*
//**************************************************************************************************
// Wave Out Callback
//
// Event handler called by Windows for dealing with an open wave device
//
// In:
//    hwo        = Handle to output device
//    uMsg       = Message being sent
//    dwInstance = User defined data (not used in here)
//    pWHdr     -> Current wave header (if applicable)
//    dwParam2   = not used

void __stdcall WaveOutDone(HWAVEOUT hwo, u32 umsg, u32 dwInstance, WAVEHDR *wHdr, u32 dwParam2)
{
	if (umsg != WOM_DONE || !is_open) return;

	apu.EmuAPU(wHdr->lpData, bufSize / wav.fmt.nBlockAlign, true);
	waveOutWrite(wav.handle, wHdr, sizeof(WAVEHDR));
}


//**************************************************************************************************
void WavInit()
{
	wav.fmt.wFormatTag		= WAVE_FORMAT_PCM;
	wav.fmt.nChannels		= 2;
	wav.fmt.nSamplesPerSec	= 32000;
	wav.fmt.nAvgBytesPerSec	= 2 * (16 >> 3) * 32000;
	wav.fmt.nBlockAlign		= 2 * (16 >> 3);
	wav.fmt.wBitsPerSample	= 16;
	wav.fmt.cbSize			= 0;

	bufSize	= (100 * 32000 * 2 * 2) / 1000;		//100ms at 32kHz 16-bit stereo
	pBuf	= malloc(bufSize * 2);
}


//**************************************************************************************************
void WavQuit()
{
	if (is_open) WavClose();					//Close device is it's open
	if (pBuf) free(pBuf);						//Free up allocated memory
}


//**************************************************************************************************
b8 WavOpen()
{
	s32	error;

	//Open audio device ------------------------
	error = waveOutOpen(&wav.handle, WAVE_MAPPER , &wav.fmt, (u32)WaveOutDone, 0, CALLBACK_FUNCTION | WAVE_ALLOWSYNC);

	if (error == MMSYSERR_NOERROR)
	{
		is_open = true;

		//Initialize wave blocks ---------------
		memset(&wav.hdr[0], 0, sizeof(WAVEHDR));
		wav.hdr[0].dwBufferLength = bufSize;
		wav.hdr[0].lpData = (s8*)pBuf;
		waveOutPrepareHeader(wav.handle, &wav.hdr[0], sizeof(WAVEHDR));
		wav.hdr[0].dwUser = 0;

		memset(&wav.hdr[1], 0, sizeof(WAVEHDR));
		wav.hdr[1].dwBufferLength = bufSize;
		wav.hdr[1].lpData = (s8*)((u32)pBuf + bufSize);
		waveOutPrepareHeader(wav.handle, &wav.hdr[1], sizeof(WAVEHDR));
		wav.hdr[1].dwUser = 1;

		//Start output -------------------------
		WaveOutDone(wav.handle, WOM_DONE, 0, &wav.hdr[0], 0);
		WaveOutDone(wav.handle, WOM_DONE, 0, &wav.hdr[1], 0);

		return 1;
	}

	return 0;
}


//**************************************************************************************************
void WavClose()
{
	is_open = false;

	waveOutReset(wav.handle);					//Tell Windows to reset the output device
	waveOutUnprepareHeader(wav.handle, &wav.hdr[0], sizeof(WAVEHDR));
	waveOutUnprepareHeader(wav.handle, &wav.hdr[1], sizeof(WAVEHDR));
	waveOutClose(wav.handle);					//Close output device

	wav.handle = NULL;
}
*/


