// ToolboxBar.cpp : implementation file
//

#include "stdafx.h"
#include "MapEdit.h"
#include "ToolboxBar.h"
#include "mainfrm.h"

#include <float.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TILE_PLACE 0
#define TILE_PICK 1
#define TILE_INFO 2
#define TILE_SELECT 3

#define MODE_MAP 0
#define MODE_DOOR 1
#define MODE_SPRITE 2
#define MODE_ENEMY 3

#define DOOR_NORMAL 0
#define DOOR_DESTSEEK 1
#define DOOR_ADD 2

#define SPRITE_NORMAL 0
#define SPRITE_ADD 1


/////////////////////////////////////////////////////////////////////////////
// CToolBox dialog


CToolBox::CToolBox(CWnd* pParent /*=NULL*/)
	: CDialogBar()
{
	//{{AFX_DATA_INIT(CToolBox)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	ToolBarHeight = 64;
	TilePalHeight = 292;
	DoorBarHeight = 188;
	SpriteBarHeight = 298;

	ToolBarShown = FALSE;
	TilePalShown = FALSE;
	DoorBarShown = FALSE;
	SpriteBarShown = FALSE;

	bartitles[0] = "Tools";
	bartitles[1] = "Tile Palette";
	bartitles[2] = "Door Tools";
	bartitles[3] = "Sprite Tools";
	bartitles[4] = "Enemy groups";

	m_pParent = pParent;
}


void CToolBox::DoDataExchange(CDataExchange* pDX)
{
	CDialogBar::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CToolBox)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CToolBox, CDialogBar)
	//{{AFX_MSG_MAP(CToolBox)
	ON_WM_SETCURSOR()
	ON_WM_MOUSEMOVE()
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_MOVE()
	ON_WM_MOVING()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CToolBox message handlers



BOOL CToolBox::OnInitDialog() 
{
	//CDialogBar::OnInitDialog();
	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

LRESULT CToolBox::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	switch(message)
	{
	case TM_RELOAD_ROM:
		m_wndTilePal.SendMessage(message);
		m_wndDoorBar.SendMessage(message);
		m_wndSpriteBar.SendMessage(message);
		m_wndEnemyBar.SendMessage(message);
		break;

	case TM_SELSECTOR:
		m_wndTilePal.SendMessage(message, wParam, lParam);
		break;
	}
	return CDialogBar::WindowProc(message, wParam, lParam);
}


void CToolBox::Initialize(CWnd *pFrameWnd)
{
	// initialize windows and stuff here
	m_wndToolBar.Create(IDR_TOOL_GENERAL, this, pFrameWnd);
	m_wndTilePal.Create(IDR_TOOL_TILEPAL, this);
	m_wndDoorBar.Create(IDR_TOOL_DOORS, this);
	m_wndSpriteBar.Create(IDR_TOOL_SPRITES, this);
	m_wndEnemyBar.Create(IDR_TOOL_ENEMY, this);

	// Show toolbar
	m_wndToolBar.ShowWindow(SW_NORMAL);
	ToolBarShown = TRUE;

	SwitchEditMode(MODE_MAP);

	// initialize tilepalette members
	m_wndTilePal.Rom = Rom;
	m_wndSpriteBar.Rom = Rom;
	m_wndEnemyBar.Rom = Rom;

	grab_bar.CreateCompatibleDC(GetDC());
	//grab_bar_on.CreateCompatibleDC(GetDC());

	CBitmap bar1, bar2;
	bar1.LoadBitmap(IDB_TILEBAR);
	grab_bar.SelectObject(bar1);

	bar2.LoadBitmap(IDB_TILEBAR_ON);
	grab_bar_on.SelectObject(bar2);

	//buffer.CreateCompatibleDC(GetDC());
	//SelectObject((HDC)buffer, CreateCompatibleBitmap((HDC)*GetDC(), 200, 500));
	
	//font.CreatePointFont(90, "Tahoma");
	//buffer.SelectObject(font);
	//buffer.SetTextColor(RGB(255,255,255));
	//buffer.SetBkMode(TRANSPARENT);


	//m_wndTilePal.buffer.CreateCompatibleDC(GetDC());
	//SelectObject((HDC)m_wndTilePal.buffer, CreateCompatibleBitmap((HDC)*GetDC(),150,280));


	CalcLayout();
}


void CToolBox::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	CDC buf;
	CBitmap bmp;
	CFont font;

	buf.CreateCompatibleDC(&dc);
	bmp.CreateCompatibleBitmap(&dc, 175, 500);
	font.CreatePointFont(90, "Tahoma");

	CBitmap *pBmpOld = buf.SelectObject(&bmp);
	CFont *pFntOld = buf.SelectObject(&font);
	buf.SetBkMode(TRANSPARENT);

	int y = 0;


	buf.FillSolidRect(0,0,175,500,GetSysColor(COLOR_3DFACE));
	//buf.FillSolidRect(2,2,175,height,RGB(0,0,0));
	buf.BitBlt(2, 2, 167, 25, &grab_bar, 0, 0, SRCCOPY);
	buf.SetTextColor(RGB(255,255,255));
	buf.TextOut(25,5,bartitles[0]);

	if(ToolBarShown)
	{
		CRect rect;
		m_wndToolBar.GetWindowRect(rect);
		y = rect.Height()-1;
	}

	y+=20;

	buf.BitBlt(2, y, 167, 25, &grab_bar, 0, 0, SRCCOPY);
	buf.TextOut(25, y+2, bartitles[bar_open+1]);

	dc.BitBlt(0,0,170,height,&buf, 0, 0, SRCCOPY);

	buf.SelectObject(pBmpOld);
	buf.SelectObject(pFntOld);

}

BOOL CToolBox::OnEraseBkgnd(CDC* pDC)
{
	//return CDialogBar::OnEraseBkgnd(pDC);

	//CRect rect;
	//GetClientRect(rect);

	//pDC->FillSolidRect(rect, GetSysColor(COLOR_3DFACE));
	//pDC->FillSolidRect(0, 0, 175, 1000, GetSysColor(COLOR_3DFACE));

	Invalidate(FALSE);

	return FALSE;
}

void CToolBox::OnMouseMove(UINT nFlags, CPoint point) 
{
	m_x = point.x;
	m_y = point.y;

	CDialogBar::OnMouseMove(nFlags, point);
}

BOOL CToolBox::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	if(pWnd != this || message == 0)
	{
		SetCursor(LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW)));
		return TRUE;
	}

	int y = 0;
	if(ToolBarShown)
	{
		CRect rect;
		m_wndToolBar.GetWindowRect(rect);
		y = rect.Height();
	}
	y+=20;

	if((m_y > 4 && m_y < 23) ||
	   (m_y > y && m_y < y + 17))
	{
		if(m_x > 24)
		{
			SetCursor(LoadCursor(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDC_CLICKY)));
			return TRUE;
		}
		else
		{
			SetCursor(LoadCursor(NULL, MAKEINTRESOURCE(IDC_SIZEALL)));
			return TRUE;
		}
	}
	else
	{
		SetCursor(LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW)));
		return TRUE;
	}

}


void CToolBox::OnLButtonDown(UINT nFlags, CPoint point) 
{
	int m_x = point.x;
	int m_y = point.y;

	int y = 0;
	if(ToolBarShown)
	{
		CRect rect;
		m_wndToolBar.GetWindowRect(rect);
		y = rect.Height();
	}
	y+=20;


	if(m_x > 24)
	{
		if(((CMainFrame*)GetParent())->IsDoorSeeking())
			return;

		if(m_y > 4 && m_y < 23)
		{
			ToolBarShown = !ToolBarShown;
			CalcLayout();
		}
		else if(m_y > y && m_y < y + 17)
		{
			CMenu menu;
			CMenu *popup;

			menu.LoadMenu(IDR_MAINFRAME);
			popup = menu.GetSubMenu(3);

			CPoint pt;
			pt.x = 169;
			pt.y = y+18;

			ClientToScreen(&pt);

			popup->TrackPopupMenu(TPM_RIGHTALIGN, pt.x, pt.y, this);
		}

		return;

	}

	CDialogBar::OnLButtonDown(nFlags, point);
}

void CToolBox::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	int y = 0;
	if(ToolBarShown)
	{
		CRect rect;
		m_wndToolBar.GetWindowRect(rect);
		y = rect.Height();
	}
	y+=20;

	if((m_y > 4 && m_y < 23) ||
	   (m_y > y && m_y < y + 17))
	{
		OnLButtonDown(nFlags, point);
		return;
	}

	CDialogBar::OnLButtonDblClk(nFlags, point);
}









void CToolBox::OnMove(int x, int y) 
{
	CalcLayout();

	CDialogBar::OnMove(x, y);

	CalcLayout();
}

void CToolBox::OnMoving(UINT nSide, LPRECT lpRect)
{
	CDialogBar::OnMoving(nSide, lpRect);
}

CSize CToolBox::CalcDynamicLayout( int nLength, DWORD dwMode)
{
	if(!IsFloating())
	{
		
	}
	return CDialogBar::CalcDynamicLayout(nLength, dwMode);
}


void CToolBox::CalcLayout()
{
	if(!m_wndToolBar.m_hWnd ||
	   !m_wndTilePal.m_hWnd ||
	   !m_wndDoorBar.m_hWnd ||
	   !m_wndSpriteBar.m_hWnd ||
	   !m_wndEnemyBar.m_hWnd)
	{
		return;
	}

	// set window positions

	// rects for currently shown window and toolbar
	CRect winRect, toolRect;

	CWnd* current_win;

	switch(bar_open)
	{
	case 0:
		current_win = &m_wndTilePal;
		break;
	case 1:
		current_win = &m_wndDoorBar;
		break;
	case 2:
		current_win = &m_wndSpriteBar;
		break;
	case 3:
		current_win = &m_wndEnemyBar;
		break;
	}

	current_win->GetWindowRect(winRect);
	m_wndToolBar.GetWindowRect(toolRect);

	int offset = 0; // offset for editor window

	if(ToolBarShown)
	{
		toolRect.left = 2;
		toolRect.top = 20;
		toolRect.bottom = toolRect.top+ToolBarHeight;

		offset = toolRect.top+toolRect.Height();

		m_wndToolBar.ShowWindow(SW_NORMAL);
		m_wndToolBar.MoveWindow(toolRect);
	}
	else
	{
		offset = 20;

		m_wndToolBar.ShowWindow(SW_HIDE);
	}

	
	// now set position of current window

	winRect.bottom = offset+17+winRect.Height();
	winRect.right = 171;
	winRect.left = 2;
	winRect.top=offset+17;

	// total vertical space useable by the window
	int availHeight;

	// Rect used to facilitate available space computations
	CRect mainRect;
	GetWindowRect(mainRect);

	if(!IsFloating())
	{
		//AfxMessageBox("Control bar is docked.");

		// If the bar is docked, we give the selected window to the
		// main frame, so it can be made larger than the height of
		// the control bar in which it usually resides.

		// Adjust things a bit

		GetParent()->ScreenToClient(mainRect);

		winRect.OffsetRect(-2,mainRect.top);

		current_win->SetParent(GetParent());

		current_win->MoveWindow(winRect);

		height = toolRect.bottom+18;

		// Now, compute the amount of room we have to play around with.
		// Since the control bar is docked, we can take the height of
		// the main frame's client area as the height of this bar, and
		// subtract the tool window and headers from that.

		CRect client;
		GetParent()->GetClientRect(client);

		availHeight = client.Height();

		if(ToolBarShown) availHeight-=(toolRect.bottom+16+mainRect.top+2);
		else availHeight-=36;
		
	}
	else
	{
		//AfxMessageBox("Control bar is floating.");

		current_win->SetParent(this);
		current_win->MoveWindow(winRect);
		height = winRect.bottom;


		// Compute available space
		availHeight = mainRect.Height();

		if(ToolBarShown) availHeight-=(toolRect.bottom+18);
		else availHeight-=36;


	}

	CString s;
	s.Format("Available space: %dpx", availHeight);
	//AfxMessageBox(s);

	current_win->SendMessage(TM_RECALC_SPACE, (WPARAM)availHeight);



	Invalidate(FALSE);
}



void CToolBox::SwitchEditMode(int nMode)
{
	TilePalShown = FALSE;
	DoorBarShown = FALSE;
	SpriteBarShown = FALSE;

	m_wndTilePal.ShowWindow(SW_HIDE);
	m_wndDoorBar.ShowWindow(SW_HIDE);
	m_wndSpriteBar.ShowWindow(SW_HIDE);
	m_wndEnemyBar.ShowWindow(SW_HIDE);

	switch(nMode)
	{
	case MODE_MAP:
		bar_open = 0;
		m_wndTilePal.ShowWindow(SW_NORMAL);
		break;
	case MODE_DOOR:
		bar_open = 1;
		m_wndDoorBar.ShowWindow(SW_NORMAL);
		break;
	case MODE_SPRITE:
		bar_open = 2;
		m_wndSpriteBar.ShowWindow(SW_NORMAL);
		break;
	case MODE_ENEMY:
		bar_open = 3;
		m_wndEnemyBar.ShowWindow(SW_NORMAL);
	}

	CalcLayout();

	m_pParent->Invalidate(FALSE);

}








int CToolBox::GetSelTile()
{
	return m_wndTilePal.curTile;
}

void CToolBox::SetSelTile(int set, int tile)
{
	m_wndTilePal.gSet = set;
	m_wndTilePal.curTile = tile;

	m_wndTilePal.ScrollToTile(set, tile);
}

void CToolBox::SetGlobalSet(int set)
{
	// note: the call to this is failing because the view is
	// calling it through a null pointer to the ToolBox object
	m_wndTilePal.gSet = set;
	m_wndTilePal.Invalidate(FALSE);
}

void CToolBox::SetGlobalPal(int pal)
{
	m_wndTilePal.gPal = pal;
	m_wndTilePal.Invalidate(FALSE);
}


int CToolBox::GetGlobalSet()
{
	return m_wndTilePal.gSet;
}


bool CToolBox::IsDraggingSprite(bool bClear)
{
	bool ret = m_wndSpriteBar.is_dragging;

	if(bClear && ret)
		m_wndSpriteBar.is_dragging = false;

	return ret;
}

int CToolBox::GetSelectedSprite()
{
	return m_wndSpriteBar.sel_sprite;
}




int CToolBox::GetSelectedEnemyCluster()
{
	return m_wndEnemyBar.sel_cluster;
}



/////////////////////////////////////////////////////////////////////////////
// Tile palette sub-window


CTilePalette::CTilePalette(CWnd* pParent /*=NULL*/)
	: CDialog()
{
	//{{AFX_DATA_INIT(CToolboxBar)
	//}}AFX_DATA_INIT

	scrollPos = 0;
	gPal = 0;
	gSet = -1;

	tileRect.top = 16;
	tileRect.left = 6;
	tileRect.bottom = 8*33+1+16;
	tileRect.right = 4*33+1+6;
}


void CTilePalette::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTilePalette)
	DDX_Control(pDX, IDC_SCROLLBAR, m_ScrollBar);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTilePalette, CDialog)
	//{{AFX_MSG_MAP(CTilePalette)
	ON_WM_PAINT()
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_VSCROLL()
	ON_WM_SHOWWINDOW()
	ON_WM_MOUSEWHEEL()
	ON_WM_MOUSEMOVE()
	ON_WM_ERASEBKGND()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTilePalette message handlers

BOOL CTilePalette::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_wndSector.Create(IDR_TOOL_SECTORPROP, this);

	m_wndSector.GetWindowRect(sectorRect);

	bar_down.LoadBitmap(IDB_TILEBAR);
	bar_up.LoadBitmap(IDB_TILEBAR_UP);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CTilePalette::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	//((CScrollBar*)GetDlgItem(IDC_SCROLLBAR))->SetScrollRange(0, 248);
}


BOOL CTilePalette::OnEraseBkgnd(CDC* pDC)
{
	//return CDialog::OnEraseBkgnd(pDC);

	//CRect rect;
	//GetWindowRect(rect);
	//rect.bottom = 900;
	//pDC->FillSolidRect(rect, GetSysColor(COLOR_3DFACE));

	Invalidate(FALSE);

	return TRUE;
}


void CTilePalette::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	CDC bar;
	CDC buf;
	CBitmap bmp;
	CFont font;
	CRect rect;


	GetWindowRect(rect);
	int w = rect.Width();
	int h = rect.Height();

	int x = tileRect.left;
	int y = tileRect.top;

	bar.CreateCompatibleDC(&dc);
	buf.CreateCompatibleDC(&dc);
	bmp.CreateCompatibleBitmap(&dc, w, h);
	font.CreatePointFont(90, "Tahoma");

	CBitmap *pBmpOld = buf.SelectObject(&bmp);
	CBitmap *pBarOld;
	CFont *pFntOld = buf.SelectObject(&font);

	buf.SetTextColor(0x00FFFFFF);
	buf.SetBkMode(TRANSPARENT);
	buf.FillSolidRect(0, 0, w, h, GetSysColor(COLOR_3DFACE));

	buf.FillSolidRect(tileRect.left,tileRect.top,tileRect.Width(),tileRect.Height(),RGB(0,0,0));
	if(gSet != -1)
	{
		Rom->DrawSet(&buf, x, y, gSet, gPal, 4, m_nRows, scrollPos);
	}

	// draw blue rectangle around selected tile
	buf.Draw3dRect(x+(curTile%4)*33,y+(curTile/4)*33-scrollPos*33, 34,34,		RGB(45,45,244),RGB(45,45,244));
	buf.Draw3dRect(x+(curTile%4)*33+1,y+(curTile/4)*33+1-scrollPos*33, 32,32,	RGB(45,45,244),RGB(45,45,244));


	CRect srect;
	m_wndSector.GetWindowRect(srect);

	int ypos = rect.Height()-23;

	if(m_bShowSector)
	{
		//ypos-=srect.Height();
		pBarOld = bar.SelectObject(&bar_down);
	}
	else
	{
		pBarOld = bar.SelectObject(&bar_up);
	}

	buf.BitBlt(barRect.left, barRect.top, barRect.Width(), barRect.Height(), &bar, 1, 0, SRCCOPY);
	buf.TextOut(barRect.left + 23, barRect.top + 2, "Sector properties");

	dc.BitBlt(0,0,w,h,&buf,0,0,SRCCOPY);

	buf.SelectObject(pBmpOld);
	buf.SelectObject(pFntOld);
	bar.SelectObject(pBarOld);
}


BOOL CTilePalette::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	if(pMsg->message == WM_MOUSEWHEEL)
	{
		SendMessage(pMsg->message, pMsg->wParam, pMsg->lParam);
		return TRUE;
	}
	return CDialog::PreTranslateMessage(pMsg);
}



void CTilePalette::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{

	CDialog::OnKeyDown(nChar, nRepCnt, nFlags);
}



void CTilePalette::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if(barRect.PtInRect(point))
	{
		m_bShowSector = !m_bShowSector;

		if(m_bShowSector)
			m_wndSector.ShowWindow(SW_SHOWNORMAL);
		else
			m_wndSector.ShowWindow(SW_HIDE);

		CRect rect;
		GetWindowRect(rect);
		RecalcSpace(rect.Height());
		/*if(!m_bShowSector)
		{
			m_nTrans = 1;
			m_bShowSector = true;
			m_wndSector.ShowWindow(SW_SHOWNORMAL);
		}
		else
			m_nTrans = 0;

		SetTimer(0, 10, NULL);
		OnTimer(0);*/
	}
	else if(tileRect.PtInRect(point))
	{
		CPoint pt(point);
		pt.Offset(-tileRect.left, -tileRect.top);

		int x = pt.x/33;
		int y = pt.y/33;

		curTile = x+(y+scrollPos)*4;

		InvalidateRect(tileRect, FALSE);
	}

	CDialog::OnLButtonDown(nFlags, point);
}




BOOL CTilePalette::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	scrollPos -= (int)_copysign(3, zDelta);

	if(scrollPos < 0) scrollPos = 0;
	if(scrollPos > 248) scrollPos = 248;

	((CScrollBar*)GetDlgItem(IDC_SCROLLBAR))->SetScrollPos(scrollPos, TRUE);

	InvalidateRect(tileRect, FALSE);

	return CDialog::OnMouseWheel(nFlags, zDelta, pt);
}


void CTilePalette::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	//AfxMessageBox("Mouse movement in tile palette window");
	CDialog::OnMouseMove(nFlags, point);
}


void CTilePalette::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	int max = 256-m_nRows;
	switch(nSBCode)
	{
	case SB_THUMBPOSITION:
	case SB_THUMBTRACK:
		scrollPos=nPos;
		break;
	case SB_PAGEDOWN:
		scrollPos+=2;
		break;
	case SB_LINEDOWN:
		scrollPos++;
		break;
	case SB_PAGEUP:
		scrollPos-=2;
		break;
	case SB_LINEUP:
		scrollPos--;
		break;
	}

	if(scrollPos < 0) scrollPos = 0;
	if(scrollPos > max) scrollPos = max;

	((CScrollBar*)GetDlgItem(IDC_SCROLLBAR))->SetScrollPos(scrollPos, TRUE);

	InvalidateRect(tileRect, FALSE);

	//CDialogBar::OnVScroll(nSBCode, nPos, pScrollBar);
}




void CTilePalette::ScrollToTile(int set, int tile)
{
	int s = tile/4;
	if(s > 256-m_nRows) s = 256-m_nRows;

	((CScrollBar*)GetDlgItem(IDC_SCROLLBAR))->SetScrollPos(s);
	scrollPos = s;

	Invalidate(FALSE);
}



void CTilePalette::CalcTileHeight(int nRows)
{
	int scroff;
	if(nRows == -1)
		nRows = m_nRows;
	else
	{
		scroff = m_nRows - nRows;
		m_nRows = nRows;
	}


	tileRect.top = 8;
	tileRect.left = 8;
	tileRect.bottom = tileRect.top + nRows*33 + 1;
	tileRect.right = tileRect.left + 4*33 + 1;

	CRect scrollrect;

	m_ScrollBar.GetWindowRect(scrollrect);

	int sw = scrollrect.Width();

	scrollrect.top = tileRect.top - 4;
	scrollrect.bottom = tileRect.bottom + 4;

	scrollrect.left = tileRect.right + 3;
	scrollrect.right = scrollrect.left + sw;


	// Scrollbar position and information
	m_ScrollBar.MoveWindow(scrollrect);
	m_ScrollBar.SetScrollRange(0, 255);
	
	SCROLLINFO scr;
	scr.fMask = SIF_PAGE;
	scr.nPage = nRows;

	m_ScrollBar.SetScrollInfo(&scr);


	// Show the thingy bar at the bottom
	CRect rect,main;
	GetClientRect(main);

	m_wndSector.GetWindowRect(rect);

	int offset = main.Height()-rect.Height()-1;
	int height = rect.Height();

	rect.top = offset;
	rect.bottom = offset+height;
	rect.left = 0;
	rect.right = 175;

	m_wndSector.MoveWindow(rect);

	if(m_bShowSector)
		barRect = CRect(-1,rect.top-23,175,rect.top-2);
	else
		barRect = CRect(-1,main.Height()-19,175,main.Height());
}



void CTilePalette::RecalcSpace(int height)
{
	// Resize the window
	CRect rect;
	CRect parent;
	GetWindowRect(rect);
	GetParent()->GetWindowRect(parent);

	rect.bottom = (parent.bottom)-1;

	GetParent()->ScreenToClient(rect);

	MoveWindow(rect);


	// Other stuff

	CRect rc;
	m_wndSector.GetWindowRect(rc);

	height-=19;
	if(m_bShowSector) height-=sectorRect.Height();


	int n = (height - 14) / 33;
	if(n<1)n=1;

	CalcTileHeight(n);



}

LRESULT CTilePalette::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	switch(message)
	{
	case TM_RECALC_SPACE:
		RecalcSpace((int)wParam);
		break;

	case TM_RELOAD_ROM:
		m_wndSector.InitItemBox(Rom);
		break;

	case TM_SELSECTOR:
		m_nSelCount = wParam;
		m_Sel = (SelectedSector*)lParam;

		if(m_nSelCount == 0)
		{
			m_wndSector.Enable(FALSE);
			return FALSE;
		}
		else
			m_wndSector.Enable(TRUE);

		SelectedSector s = m_Sel[0];
		m_wndSector.SetSectorFlags(Rom->sector_map[s.y][s.x]);
		break;

	case SP_CHANGE:
		for(int i = 0; i < m_nSelCount; i++)
		{
			Rom->sector_map[m_Sel[i].y][m_Sel[i].x] = m_wndSector.GetSectorFlags();
		}
		break;
	}
	return CDialog::WindowProc(message, wParam, lParam);
}



void CTilePalette::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(nIDEvent == 0)
	{
		CRect rect;
		m_wndSector.GetWindowRect(rect);

		if(m_nTrans == 0)	// Shrink window
		{
			rect.top+=10;

			if(rect.top >= rect.bottom)
			{
				m_bShowSector = false;
				m_wndSector.ShowWindow(SW_HIDE);

				KillTimer(0);
			}
			m_wndSector.MoveWindow(rect);
		}
		else				// Enlarge window
		{
			rect.top-=10;

			if(rect.Height() >= sectorRect.Height())
			{
				rect.top+= rect.Height()-sectorRect.Height();
				KillTimer(0);
			}
			m_wndSector.MoveWindow(rect);
		}
		// Recalculate space
		CalcTileHeight(m_nRows);
		//CRect main;
		//GetWindowRect(main);
		//RecalcSpace(main.Height());

	}
	CDialog::OnTimer(nIDEvent);
}






/////////////////////////////////////////////////////////////////////////////
// CGenToolWin dialog


CGenToolWin::CGenToolWin(CWnd* pParent /*=NULL*/)
	: CDialog(CGenToolWin::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGenToolWin)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CGenToolWin::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGenToolWin)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGenToolWin, CDialog)
	//{{AFX_MSG_MAP(CGenToolWin)
	ON_COMMAND(ID_VIEW_ZOOM_100, OnViewZoom100)
	ON_COMMAND(ID_VIEW_ZOOM_150, OnViewZoom150)
	ON_COMMAND(ID_VIEW_ZOOM_200, OnViewZoom200)
	ON_COMMAND(ID_VIEW_ZOOM_300, OnViewZoom300)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGenToolWin message handlers

BOOL CGenToolWin::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	toolbar.Create(WS_CHILD | CCS_NORESIZE | CCS_NODIVIDER | CCS_NOPARENTALIGN | TBSTYLE_FLAT | TBSTYLE_LIST, CRect(5, 2, 120, 36), this, 31338);

	toolbar.SetExtendedStyle(TBSTYLE_EX_DRAWDDARROWS);

	toolbar.AddBitmap(1, IDB_TOOL_MAG);
	toolbar.AddStrings("Zoom");

	TBBUTTON btn;

	btn.iBitmap = 0;
	btn.idCommand = 0;
	btn.fsState = TBSTATE_ENABLED;
	btn.fsStyle = TBSTYLE_BUTTON|TBSTYLE_DROPDOWN;
	btn.iString = 0;
	btn.idCommand = ID_TOOLS_ENEMYCLUSTER;

	toolbar.AddButtons(1, &btn);


	toolbar.ShowWindow(SW_NORMAL);


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}




BOOL CGenToolWin::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	// TODO: Add your specialized code here and/or call the base class
#define lpnm   ((LPNMHDR)lParam)
#define lpnmTB ((LPNMTOOLBAR)lParam)
	
	switch(lpnm->code)
	{
	case TBN_DROPDOWN:
		//drop down button was hit
		//handle appropriately

		HMENU hmenu = LoadMenu(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME));

		CMenu *menu;
		menu = menu->FromHandle(hmenu);

		// Get zoom submenu
		CMenu *pSubMenu = menu->GetSubMenu(2)->GetSubMenu(6);

		if(!pSubMenu) return false;

		// Show the popup menu
		CRect rect;
		toolbar.GetItemRect(0, rect);

		toolbar.ClientToScreen(rect);

		pSubMenu->TrackPopupMenu(TPM_LEFTALIGN, rect.left, rect.bottom, this);

		return FALSE;	//indicates the TBN_DROPDOWN
						//notification was handled.
	}


	return CDialog::OnNotify(wParam, lParam, pResult);
}


#define currview ((CMapEditView*)((CMainFrame*)m_pFrameWnd)->GetActiveView())

void CGenToolWin::OnViewZoom100() 
{
	if(currview) currview->SetZoomLevel(1.0);
}



void CGenToolWin::OnViewZoom150() 
{
	if(currview) currview->SetZoomLevel(1.5);
}



void CGenToolWin::OnViewZoom200() 
{
	if(currview) currview->SetZoomLevel(2.0);
}



void CGenToolWin::OnViewZoom300() 
{
	if(currview) currview->SetZoomLevel(3.0);
}




BOOL CGenToolWin::Create(UINT nIDTemplate, CWnd* pParentWnd, CWnd* pFrameWnd)
{
	m_pFrameWnd = pFrameWnd;
	return CDialog::Create(nIDTemplate, pParentWnd);
}






/////////////////////////////////////////////////////////////////////////////
// CDoorToolWin dialog


CDoorToolWin::CDoorToolWin(CWnd* pParent /*=NULL*/)
	: CDialog(CDoorToolWin::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDoorToolWin)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDoorToolWin::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDoorToolWin)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDoorToolWin, CDialog)
	//{{AFX_MSG_MAP(CDoorToolWin)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDoorToolWin message handlers




LRESULT CDoorToolWin::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	switch(message)
	{
	case TM_RECALC_SPACE:
		RecalcSpace((int)wParam);
		break;
	}
	return CDialog::WindowProc(message, wParam, lParam);
}


void CDoorToolWin::RecalcSpace(int height)
{
	// Resize the window
	CRect rect;
	CRect parent;
	GetWindowRect(rect);
	GetParent()->GetWindowRect(parent);

	rect.bottom = (parent.bottom)-1;

	GetParent()->ScreenToClient(rect);

	MoveWindow(rect);
}


/////////////////////////////////////////////////////////////////////////////
// CSpriteToolWin dialog


CSpriteToolWin::CSpriteToolWin(CWnd* pParent /*=NULL*/)
	: CDialog(CSpriteToolWin::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSpriteToolWin)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSpriteToolWin::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSpriteToolWin)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSpriteToolWin, CDialog)
	//{{AFX_MSG_MAP(CSpriteToolWin)
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSpriteToolWin message handlers


BOOL CSpriteToolWin::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	listbox.CreateList(2,2,150,64,1583,4,this,0);

	BtnClr clr = {
		listbox.GetBtnColor(COLORSET_NORMAL, BTN_BORDER),	// border
		listbox.GetBtnColor(COLORSET_NORMAL, BTN_FACE),	// face
		listbox.GetBtnColor(COLORSET_NORMAL, BTN_HIGHLIGHT),	// highlight
		listbox.GetBtnColor(COLORSET_NORMAL, BTN_SHADOW)		// shadow
	};

	listbox.SetBtnColors(&clr, NULL, NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

LRESULT CSpriteToolWin::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch(message)
	{
	case WM_MOUSEWHEEL:
	{
		// Send mouse wheel messages to the listbox
		short zDelta = HIWORD(wParam);
		int scroll;
		if(zDelta > 0) scroll = -3;
		if(zDelta < 0) scroll = 3;
		listbox.ScrollBy(scroll);
	}
	break;

	case BM_DRAGITEM:
		is_dragging = true;
		break;
	case BM_CANCELDRAGITEM:
		is_dragging = false;
		break;

	case BM_SELECTITEM:
		sel_sprite = listbox.GetSelected();
		break;

	case BM_DRAWITEM:
	{
		if(!Rom->is_loaded)
			return FALSE;


		int item = wParam;
		CDC *dc = (CDC*)lParam;

		int spr = Rom->tpt[item].sprite;

		// Get the sprite
		//SpriteGfx * sprite = &Rom->sprite_gfx[sprConv[spr]];

		// Draw the sprite
		//sprite->Draw(dc, 3, 3, Rom->pal[Rom->sprite_gfx[sprConv[spr]].palette]);

		Rom->sprites[spr].Draw(dc, 3, 3, SOUTH|FIRST, Rom);

		CString top;
		CString adr;
		CString text;
		String *str = NULL;
		char* buf = NULL;

		top.Format("TPT Entry %d", item);

		unsigned int address = Rom->tpt[item].pointer;

		adr.Format("$%X   %s", address, address==0?"[No text]":"");

		if(Rom->tpt[item].pointer)
		{
			str = Rom->ReadString(Rom->RomFile, SNESToHex(Rom->tpt[item].pointer), Rom->ccTable);
			buf = Rom->ParseHeader(str->str, str->len, Rom->ccTable, Rom->comprTable);

			//buf = new char[1024];
			//sprintf(buf, "Hi");
			text.Format("%s", buf);
		}
		else
			text.Format("");


		CFont font;	// new display font
		font.CreatePointFont(70, "Microsoft Sans Serif");

		CFont *fntOld = dc->SelectObject(&font);

		dc->ExtTextOut(75, 5, ETO_CLIPPED, CRect(0,0,150,64), top, NULL);
		dc->ExtTextOut(75, 20, ETO_CLIPPED, CRect(0,0,150,64), adr, NULL);

		dc->ExtTextOut(6, 48, ETO_CLIPPED, CRect(0,0,150,64), text, NULL);


		// ****NOTE TO SELF:
		// The string object needs to be a decent string class instead of
		// a simple struct. It should probably do its own allocation as well
		// as freeing of memory in its destructor.
		// Obviously, having to delete the string object's data manually is
		// extremely bad.
		if(buf) delete buf;
		if(str)
		{
			if(str->str) delete str->str;
			delete str;
		}

		dc->SelectObject(fntOld);
		
	}
	break;

	case TM_RECALC_SPACE:
		RecalcSpace(wParam);
		break;

	default:
		return CDialog::WindowProc(message, wParam, lParam);
	}
	return TRUE;
	
	return CDialog::WindowProc(message, wParam, lParam);
}


void CSpriteToolWin::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	listbox.KillMouseFocus();
	Invalidate(FALSE);
	
	CDialog::OnMouseMove(nFlags, point);
}

void CSpriteToolWin::RecalcSpace(int height)
{
	// This takes the available height and decides how to
	// size its widgets

	// Calculate the number of cells we can fit into the listbox

	int itemSpace = height - (listbox.GetButtonHeight()+listbox.GetButtonPadding())*2;
	int nItems = itemSpace / (listbox.GetItemHeight()+listbox.GetItemPadding());

	int actualHeight = nItems * (listbox.GetItemHeight()+listbox.GetItemPadding())
		             + (listbox.GetButtonHeight()+listbox.GetButtonPadding())*2;

	// Resize the window
	CRect rect;
	CRect parent;
	GetWindowRect(rect);
	GetParent()->GetWindowRect(parent);

	rect.bottom = (parent.bottom)-1;

	GetParent()->ScreenToClient(rect);

	MoveWindow(rect);


	listbox.SetPageSize(nItems);
}






/////////////////////////////////////////////////////////////////////////////
// CEnemyToolWin dialog


CEnemyToolWin::CEnemyToolWin(CWnd* pParent /*=NULL*/)
	: CDialog(CEnemyToolWin::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEnemyToolWin)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CEnemyToolWin::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEnemyToolWin)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEnemyToolWin, CDialog)
	//{{AFX_MSG_MAP(CEnemyToolWin)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_PAINT()
	ON_EN_CHANGE(IDC_EDIT_CLUSTER, OnChangeEditCluster)
	ON_BN_CLICKED(IDC_BTN_EDITCLUSTER, OnBtnEditcluster)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEnemyToolWin message handlers


BOOL CEnemyToolWin::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	listbox.CreateList(2,80, 150, 32, 203, 7, this, 0);
	listbox.ShowButtons(FALSE, TRUE);

	((CSpinButtonCtrl*)GetDlgItem(IDC_SPIN))->SetRange(202,0);
	edit_update = true;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CEnemyToolWin::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	CFont font;
	font.CreatePointFont(70, "Microsoft Sans Serif");

	CFont *pFntOld = dc.SelectObject(&font);
	dc.SetBkMode(TRANSPARENT);

	dc.FillSolidRect(0,0,172,80,GetSysColor(COLOR_3DFACE));
	dc.Draw3dRect(2, 2, 162, 57, 0, 0);

	dc.TextOut(8, 13, "1. ");
	dc.TextOut(20, 33, "2.");

	CEnemyCluster *c = &Rom->enemy_clusters[sel_cluster];
	CEnemyBattleGroup *b;

	bool drawn[230] = {false};

	int offset = 20;
	for(int i = 0; i < c->n_pri; i++)
	{
		b = &Rom->enemy_groups[c->primary[i].group];

		for(int j = 0; j < b->entrycount; j++)
		{
			int e = b->enemies[j].enemy-1;
			
			if(!drawn[e])
			{
				int spr = Rom->enemies[e].outsidePic;
				CSprite *s = &Rom->sprites[spr];

				s->Draw(&dc, offset, 22-s->height*6, SOUTH|FIRST, Rom);
				offset+= s->width*8 + 2;
				drawn[e] = true;
			}
		}
	}

	offset = 30;
	memset(&drawn, 0, sizeof(drawn));

	for(i = 0; i < c->n_sec; i++)
	{
		b = &Rom->enemy_groups[c->secondary[i].group];

		for(int j = 0; j < b->entrycount; j++)
		{
			int e = b->enemies[j].enemy-1;
			
			if(!drawn[e])
			{
				int spr = Rom->enemies[e].outsidePic;
				CSprite *s = &Rom->sprites[spr];

				s->Draw(&dc, offset, 48-s->height*6, SOUTH|FIRST, Rom);
				offset+= s->width*8 + 2;
				drawn[e] = true;
			}
		}
	}

	dc.SelectObject(pFntOld);
}


LRESULT CEnemyToolWin::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch(message)
	{
	case WM_MOUSEWHEEL:
	{
		// Send mouse wheel messages to the listbox
		short zDelta = HIWORD(wParam);
		int scroll;
		if(zDelta > 0) scroll = -3;
		if(zDelta < 0) scroll = 3;
		listbox.ScrollBy(scroll);
	}
	break;


	case BM_SELECTITEM:
		sel_cluster = listbox.GetSelected();

		edit_update = false;
		SetDlgItemInt(IDC_EDIT_CLUSTER, sel_cluster);
		edit_update = true;

		Invalidate(FALSE);
		break;

	case BM_DBLCLICK:
	{
		int item = wParam;

		CEnemyClusterDlg dlg(Rom, item);
		dlg.DoModal();
	}	
	break;

	case BM_DRAWITEM:
	{
		if(!Rom->is_loaded)
			return FALSE;

		int item = wParam;
		CDC *dc = (CDC*)lParam;

		CString s;
		s.Format("Cluster %d %s", item, (item==0?"(None)":""));

		CFont font;	// new display font
		font.CreatePointFont(70, "Microsoft Sans Serif");

		CFont *pFntOld = dc->SelectObject(&font);

		dc->TextOut(3, 2, s);

		dc->SelectObject(pFntOld);


		// Draw the first enemy in the cluster
		int e = -1;

		CEnemyCluster *c = &Rom->enemy_clusters[item];
		CEnemyBattleGroup *b;

		if(c->has_primary) for(int i = 0; i < c->n_pri; i++)
		{
			b = &Rom->enemy_groups[c->primary[i].group];
			if(b->entrycount)
			{
				e = b->enemies[0].enemy-1;
				break;
			}
		}
		if(c->has_secondary && e == -1) for(int i = 0; i < c->n_sec; i++)
		{
			b = &Rom->enemy_groups[c->secondary[i].group];
			if(b->entrycount)
			{
				e = b->enemies[0].enemy-1;
				break;
			}
		}

		if(e != -1 && item != 0)
		{
			int spr = Rom->enemies[e].outsidePic;
			CSprite *sprite = &Rom->sprites[spr];

			sprite->Draw(dc, 146-sprite->width*8, 16-sprite->height*4, SOUTH|FIRST, Rom);
		}
	}
	break;

	case TM_RECALC_SPACE:
		RecalcSpace(wParam);
		break;

	default:
		return CDialog::WindowProc(message, wParam, lParam);
	}

	return TRUE;
}



void CEnemyToolWin::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnLButtonDown(nFlags, point);
}


void CEnemyToolWin::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnMouseMove(nFlags, point);
}



void CEnemyToolWin::RecalcSpace(int height)
{
	// This takes the available height and decides how to
	// size its widgets

	// Calculate the number of cells we can fit into the listbox
	int nOffset = 75;

	int itemSpace = height - nOffset - (listbox.GetButtonHeight()+listbox.GetButtonPadding())*2;
	int nItems = itemSpace / (listbox.GetItemHeight()+listbox.GetItemPadding());

	int actualHeight = nItems * (listbox.GetItemHeight()+listbox.GetItemPadding())
		             + (listbox.GetButtonHeight()+listbox.GetButtonPadding())*2;

	// Resize the window
	CRect rect;
	CRect parent;
	GetWindowRect(rect);
	GetParent()->GetWindowRect(parent);

	rect.bottom = (parent.bottom)-1;

	GetParent()->ScreenToClient(rect);

	MoveWindow(rect);


	listbox.SetPageSize(nItems);
}



void CEnemyToolWin::OnChangeEditCluster() 
{
	if(edit_update)
	{
		int n = GetDlgItemInt(IDC_EDIT_CLUSTER);

		if(n >= 0 && n < 203)
			listbox.SetSelected(n, FALSE);
		else
			SetDlgItemInt(IDC_EDIT_CLUSTER, 202);
	}
}

void CEnemyToolWin::OnBtnEditcluster() 
{
	// TODO: Add your control notification handler code here
	if(Rom->is_loaded)
	{
		CEnemyClusterDlg dlg(Rom, listbox.GetSelected());
		dlg.DoModal();
	}
}





