#if !defined(AFX_TOOLBOXBAR_H__7257EF61_2296_4BE3_A6E6_CE7EF8D3486B__INCLUDED_)
#define AFX_TOOLBOXBAR_H__7257EF61_2296_4BE3_A6E6_CE7EF8D3486B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ToolboxBar.h : header file
//

#include "stdafx.h"
#include "Rom.h"
#include "BoxList.h"

#include "EnemyClusterDlg.h"
#include "SectorPropWnd.h"

// Classes declared in this file
class CToolBox;
class CGenToolWin;
class CTilePalette;
class CDoorToolWin;
class CSpriteToolWin;
class CEnemyToolWin;

#include "mapedit.h"
#include "mapeditdoc.h"
#include "mapeditview.h"

#define TM_RECALC_SPACE (31338+1)
#define TM_RELOAD_ROM   (31338+2)
#define TM_SELSECTOR	(31338+3)

/////////////////////////////////////////////////////////////////////////////
// CToolboxBar dialog

class CTilePalette : public CDialog
{
// Construction
public:
	void CalcTileHeight(int nRows);
	void RecalcSpace(int height);
	CTilePalette(CWnd* pParent = NULL);   // standard constructor

	void ScrollToTile(int set, int tile);
	//void OnCancel();
	//void OnOK();


	CRom *Rom;	// pointer to ROM object
	SelectedSector* m_Sel;
	int m_nSelCount;

	CBitmap bar_down,bar_up;

	int scrollPos;

	int gSet;
	int gPal;

	int curTile;

	CRect tileRect;
	CRect barRect;

	CRect sectorRect;	// stores original size for reference

	bool m_bShowSector;
	int m_nTrans;

	int m_x, m_y;
	int m_nRows;



	CSectorPropWnd m_wndSector;

// Dialog Data
	//{{AFX_DATA(CTilePalette)
	enum { IDD = IDR_TOOL_TILEPAL };
	CScrollBar	m_ScrollBar;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTilePalette)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CTilePalette)
	afx_msg void OnPaint();
	virtual BOOL OnInitDialog();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};





/////////////////////////////////////////////////////////////////////////////
// CGenToolWin dialog

class CGenToolWin : public CDialog
{
// Construction
public:
	CGenToolWin(CWnd* pParent = NULL);   // standard constructor

	CToolBarCtrl toolbar;

	CWnd* m_pFrameWnd;

// Dialog Data
	//{{AFX_DATA(CGenToolWin)
	enum { IDD = IDR_TOOL_GENERAL };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGenToolWin)
	public:
	virtual BOOL Create(UINT nIDTemplate, CWnd* pParentWnd = NULL, CWnd* pFrameWnd = NULL);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CGenToolWin)
	virtual BOOL OnInitDialog();
	afx_msg void OnViewZoom100();
	afx_msg void OnViewZoom150();
	afx_msg void OnViewZoom200();
	afx_msg void OnViewZoom300();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// CDoorToolWin dialog

class CDoorToolWin : public CDialog
{
// Construction
public:
	void RecalcSpace(int height);
	CDoorToolWin(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CDoorToolWin)
	enum { IDD = IDR_TOOL_DOORS };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDoorToolWin)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CDoorToolWin)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// CSpriteToolWin dialog

class CSpriteToolWin : public CDialog
{
// Construction
public:
	void RecalcSpace(int height);
	CSpriteToolWin(CWnd* pParent = NULL);   // standard constructor

	CRom *Rom;
	CBoxList listbox;

	int sel_sprite;		// selected sprite in listbox
	bool is_dragging;	// if a sprite is being dragged out of the listbox

// Dialog Data
	//{{AFX_DATA(CSpriteToolWin)
	enum { IDD = IDR_TOOL_SPRITES };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSpriteToolWin)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSpriteToolWin)
	virtual BOOL OnInitDialog();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// CEnemyToolWin dialog

class CEnemyToolWin : public CDialog
{
// Construction
public:
	void RecalcSpace(int height);
	CEnemyToolWin(CWnd* pParent = NULL);   // standard constructor

	CRom *Rom;

	int sel_cluster;	// Currently selected enemy cluster
	bool edit_update;
	CBoxList listbox;

// Dialog Data
	//{{AFX_DATA(CEnemyToolWin)
	enum { IDD = IDR_TOOL_ENEMY };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEnemyToolWin)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CEnemyToolWin)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	virtual BOOL OnInitDialog();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	afx_msg void OnChangeEditCluster();
	afx_msg void OnBtnEditcluster();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};








/////////////////////////////////////////////////////////////////////////////
// CToolBox dialog

class CToolBox : public CDialogBar
{
// Construction
public:
	int GetSelectedEnemyCluster();
	void SwitchEditMode(int nMode);
	void CalcLayout();
	int GetGlobalSet();
	void SetGlobalSet(int set);
	void SetGlobalPal(int pal);

	bool IsDraggingSprite(bool bClear = FALSE);
	int GetSelectedSprite();

	CToolBox(CWnd* pParent = NULL);   // standard constructor

	void Initialize(CWnd *pParent = NULL);	// handles initialization of all subwindows and such
						// things that need to be initialized

	int GetSelTile();	// returns selected tile from tile palette
	void SetSelTile(int set, int tile);	// sets selected tile and tileset


	CWnd* m_pParent;

	CRom *Rom;

	CDC grab_bar;
	CDC grab_bar_on;
	CDC buffer;
	CFont font;

	CGenToolWin		m_wndToolBar;
	CTilePalette	m_wndTilePal;
	CDoorToolWin	m_wndDoorBar;
	CSpriteToolWin	m_wndSpriteBar;
	CEnemyToolWin	m_wndEnemyBar;
	

	BOOL tools_open;
	int bar_open;
	int height;


	BOOL ToolBarShown;
	BOOL TilePalShown;
	BOOL DoorBarShown;
	BOOL SpriteBarShown;
	BOOL EnemyBarShown;
	int barShown;
	int barHover;

	CString bartitles[5];

	int h[4];

	int ToolBarHeight;
	int TilePalHeight;
	int DoorBarHeight;
	int SpriteBarHeight;

	int m_x, m_y;
	

// Dialog Data
	//{{AFX_DATA(CToolBox)
	enum { IDD = IDR_TOOLBOX };
	CStatic	m_BarSprites;
	CStatic	m_BarDoors;
	CStatic	m_BarTilePal;
	CStatic	m_BarTop;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CToolBox)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual CSize CalcDynamicLayout( int nLength, DWORD dwMode);
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CToolBox)
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnMove(int x, int y);
	afx_msg void OnMoving(UINT nSide, LPRECT lpRect);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif // !defined(AFX_TOOLBOXBAR_H__7257EF61_2296_4BE3_A6E6_CE7EF8D3486B__INCLUDED_)
